
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         sparql_parser_parse
#define yylex           sparql_parser_lex
#define yyerror         sparql_parser_error
#define yylval          sparql_parser_lval
#define yychar          sparql_parser_char
#define yydebug         sparql_parser_debug
#define yynerrs         sparql_parser_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 28 "./sparql_parser.y"

#ifdef HAVE_CONFIG_H
#include <rasqal_config.h>
#endif

#ifdef WIN32
#include <win32_rasqal_config.h>
#endif

#include <stdio.h>
#include <stdarg.h>

#include <rasqal.h>
#include <rasqal_internal.h>

#include <sparql_parser.h>

#define YY_DECL int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t yyscanner)
#define YY_NO_UNISTD_H 1
#include <sparql_lexer.h>

#include <sparql_common.h>


#if 0
#undef RASQAL_DEBUG
#define RASQAL_DEBUG 3
#endif


#define DEBUG_FH stderr

/* Make verbose error messages for syntax errors */
#define YYERROR_VERBOSE 1

/* Fail with an debug error message if RASQAL_DEBUG > 1 */
#if RASQAL_DEBUG > 1
#define YYERROR_MSG(msg) do { fputs("** YYERROR ", DEBUG_FH); fputs(msg, DEBUG_FH); fputc('\n', DEBUG_FH); YYERROR; } while(0)
#else
#define YYERROR_MSG(ignore) YYERROR
#endif

/* Slow down the grammar operation and watch it work */
#if RASQAL_DEBUG > 2
#define YYDEBUG 1
#endif

/* the lexer does not seem to track this */
#undef RASQAL_SPARQL_USE_ERROR_COLUMNS

/* Missing sparql_lexer.c/h prototypes */
int sparql_lexer_get_column(yyscan_t yyscanner);
/* Not used here */
/* void sparql_lexer_set_column(int  column_no , yyscan_t yyscanner);*/


/* What the lexer wants */
extern int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t scanner);
#define YYLEX_PARAM ((rasqal_sparql_query_language*)(((rasqal_query*)rq)->context))->scanner

/* Pure parser argument (a void*) */
#define YYPARSE_PARAM rq

/* Make the yyerror below use the rdf_parser */
#undef yyerror
#define yyerror(message) sparql_query_error((rasqal_query*)rq, message)

/* Make lex/yacc interface as small as possible */
#undef yylex
#define yylex sparql_lexer_lex


static int sparql_parse(rasqal_query* rq);
static void sparql_query_error(rasqal_query* rq, const char *message);
static void sparql_query_error_full(rasqal_query *rq, const char *message, ...) RASQAL_PRINTF_FORMAT(2, 3);



/* Line 189 of yacc.c  */
#line 160 "sparql_parser.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SELECT = 258,
     FROM = 259,
     WHERE = 260,
     OPTIONAL = 261,
     DESCRIBE = 262,
     CONSTRUCT = 263,
     ASK = 264,
     DISTINCT = 265,
     REDUCED = 266,
     LIMIT = 267,
     UNION = 268,
     PREFIX = 269,
     BASE = 270,
     BOUND = 271,
     GRAPH = 272,
     NAMED = 273,
     FILTER = 274,
     OFFSET = 275,
     ORDER = 276,
     BY = 277,
     REGEX = 278,
     ASC = 279,
     DESC = 280,
     LANGMATCHES = 281,
     A = 282,
     STRLANG = 283,
     STRDT = 284,
     STR = 285,
     IRI = 286,
     URI = 287,
     BNODE = 288,
     LANG = 289,
     DATATYPE = 290,
     ISURI = 291,
     ISBLANK = 292,
     ISLITERAL = 293,
     SAMETERM = 294,
     GROUP = 295,
     HAVING = 296,
     COUNT = 297,
     SUM = 298,
     AVG = 299,
     MIN = 300,
     MAX = 301,
     GROUP_CONCAT = 302,
     SAMPLE = 303,
     SEPARATOR = 304,
     DELETE = 305,
     INSERT = 306,
     WITH = 307,
     CLEAR = 308,
     CREATE = 309,
     SILENT = 310,
     DATA = 311,
     DROP = 312,
     LOAD = 313,
     INTO = 314,
     DEFAULT = 315,
     COALESCE = 316,
     AS = 317,
     IF = 318,
     NOT = 319,
     IN = 320,
     EXPLAIN = 321,
     LET = 322,
     SC_OR = 323,
     SC_AND = 324,
     EQ = 325,
     NEQ = 326,
     LT = 327,
     GT = 328,
     LE = 329,
     GE = 330,
     ASSIGN = 331,
     STRING_LITERAL = 332,
     DOUBLE_LITERAL = 333,
     DOUBLE_POSITIVE_LITERAL = 334,
     DOUBLE_NEGATIVE_LITERAL = 335,
     INTEGER_LITERAL = 336,
     INTEGER_POSITIVE_LITERAL = 337,
     INTEGER_NEGATIVE_LITERAL = 338,
     DECIMAL_LITERAL = 339,
     DECIMAL_POSITIVE_LITERAL = 340,
     DECIMAL_NEGATIVE_LITERAL = 341,
     BOOLEAN_LITERAL = 342,
     URI_LITERAL = 343,
     URI_LITERAL_BRACE = 344,
     QNAME_LITERAL = 345,
     QNAME_LITERAL_BRACE = 346,
     BLANK_LITERAL = 347,
     IDENTIFIER = 348
   };
#endif
/* Tokens.  */
#define SELECT 258
#define FROM 259
#define WHERE 260
#define OPTIONAL 261
#define DESCRIBE 262
#define CONSTRUCT 263
#define ASK 264
#define DISTINCT 265
#define REDUCED 266
#define LIMIT 267
#define UNION 268
#define PREFIX 269
#define BASE 270
#define BOUND 271
#define GRAPH 272
#define NAMED 273
#define FILTER 274
#define OFFSET 275
#define ORDER 276
#define BY 277
#define REGEX 278
#define ASC 279
#define DESC 280
#define LANGMATCHES 281
#define A 282
#define STRLANG 283
#define STRDT 284
#define STR 285
#define IRI 286
#define URI 287
#define BNODE 288
#define LANG 289
#define DATATYPE 290
#define ISURI 291
#define ISBLANK 292
#define ISLITERAL 293
#define SAMETERM 294
#define GROUP 295
#define HAVING 296
#define COUNT 297
#define SUM 298
#define AVG 299
#define MIN 300
#define MAX 301
#define GROUP_CONCAT 302
#define SAMPLE 303
#define SEPARATOR 304
#define DELETE 305
#define INSERT 306
#define WITH 307
#define CLEAR 308
#define CREATE 309
#define SILENT 310
#define DATA 311
#define DROP 312
#define LOAD 313
#define INTO 314
#define DEFAULT 315
#define COALESCE 316
#define AS 317
#define IF 318
#define NOT 319
#define IN 320
#define EXPLAIN 321
#define LET 322
#define SC_OR 323
#define SC_AND 324
#define EQ 325
#define NEQ 326
#define LT 327
#define GT 328
#define LE 329
#define GE 330
#define ASSIGN 331
#define STRING_LITERAL 332
#define DOUBLE_LITERAL 333
#define DOUBLE_POSITIVE_LITERAL 334
#define DOUBLE_NEGATIVE_LITERAL 335
#define INTEGER_LITERAL 336
#define INTEGER_POSITIVE_LITERAL 337
#define INTEGER_NEGATIVE_LITERAL 338
#define DECIMAL_LITERAL 339
#define DECIMAL_POSITIVE_LITERAL 340
#define DECIMAL_NEGATIVE_LITERAL 341
#define BOOLEAN_LITERAL 342
#define URI_LITERAL 343
#define URI_LITERAL_BRACE 344
#define QNAME_LITERAL 345
#define QNAME_LITERAL_BRACE 346
#define BLANK_LITERAL 347
#define IDENTIFIER 348




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 114 "./sparql_parser.y"

  raptor_sequence *seq;
  rasqal_variable *variable;
  rasqal_literal *literal;
  rasqal_triple *triple;
  rasqal_expression *expr;
  rasqal_graph_pattern *graph_pattern;
  double floating;
  raptor_uri *uri;
  unsigned char *name;
  rasqal_formula *formula;
  rasqal_update_operation *update;
  unsigned int uinteger;



/* Line 214 of yacc.c  */
#line 399 "sparql_parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 411 "sparql_parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1550

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  110
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  122
/* YYNRULES -- Number of rules.  */
#define YYNRULES  287
/* YYNRULES -- Number of states.  */
#define YYNSTATES  544

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   348

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   109,     2,     2,    76,     2,     2,     2,
      69,    70,    87,    85,    68,    86,   108,    88,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   107,
       2,     2,     2,    75,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    71,     2,    72,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    73,     2,    74,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    77,    78,    79,    80,    81,    82,    83,
      84,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,     9,    10,    12,    14,    16,    18,
      20,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      42,    45,    46,    51,    52,    59,    66,    72,    74,    76,
      79,    83,    85,    87,    93,    95,    97,    99,   101,   103,
     105,   107,   109,   110,   112,   114,   120,   126,   132,   138,
     144,   149,   150,   154,   156,   163,   169,   175,   181,   187,
     190,   194,   196,   200,   202,   204,   208,   214,   220,   222,
     228,   234,   236,   238,   241,   243,   247,   253,   259,   271,
     279,   287,   295,   299,   301,   304,   308,   312,   317,   320,
     324,   328,   333,   336,   338,   341,   346,   350,   354,   356,
     357,   359,   362,   364,   367,   369,   371,   372,   377,   380,
     382,   384,   386,   392,   394,   398,   399,   401,   404,   406,
     409,   410,   413,   416,   418,   420,   421,   425,   426,   429,
     431,   434,   437,   439,   441,   443,   445,   448,   451,   456,
     458,   459,   462,   464,   465,   469,   471,   473,   475,   476,
     480,   482,   484,   486,   488,   490,   493,   497,   501,   503,
     507,   509,   516,   519,   521,   523,   525,   527,   528,   535,
     539,   542,   546,   550,   552,   553,   557,   559,   560,   564,
     566,   569,   572,   576,   579,   580,   582,   583,   586,   589,
     590,   592,   594,   596,   598,   600,   604,   608,   611,   613,
     615,   617,   619,   621,   623,   625,   628,   631,   633,   636,
     639,   641,   643,   645,   647,   649,   651,   654,   656,   660,
     662,   666,   668,   672,   676,   680,   684,   688,   692,   696,
     701,   703,   707,   711,   714,   717,   719,   723,   727,   729,
     732,   735,   738,   740,   742,   744,   746,   748,   750,   752,
     756,   761,   766,   773,   778,   783,   788,   793,   798,   802,
     804,   813,   820,   827,   834,   839,   844,   849,   851,   858,
     867,   869,   871,   873,   875,   877,   879,   881,   883,   885,
     887,   889,   891,   893,   895,   897,   899,   901
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     111,     0,    -1,   116,   112,   113,    -1,    66,    -1,    -1,
     119,    -1,   135,    -1,   136,    -1,   138,    -1,   114,    -1,
     114,   115,    -1,   115,    -1,   140,    -1,   145,    -1,   146,
      -1,   147,    -1,   148,    -1,   149,    -1,   151,    -1,   117,
     118,    -1,    15,   101,    -1,    -1,   118,    14,   106,   101,
      -1,    -1,     3,    10,   120,   153,   157,   159,    -1,     3,
      11,   120,   153,   157,   159,    -1,     3,   120,   153,   157,
     159,    -1,   121,    -1,    87,    -1,   121,   122,    -1,   121,
      68,   122,    -1,   122,    -1,   210,    -1,    69,   214,    62,
     212,    70,    -1,   126,    -1,   127,    -1,   128,    -1,   129,
      -1,   130,    -1,   133,    -1,   134,    -1,    10,    -1,    -1,
     214,    -1,    87,    -1,    42,    69,   124,   125,    70,    -1,
      43,    69,   124,   214,    70,    -1,    44,    69,   124,   214,
      70,    -1,    45,    69,   124,   214,    70,    -1,    46,    69,
     124,   214,    70,    -1,   107,    49,    79,    90,    -1,    -1,
     132,    68,   214,    -1,   214,    -1,    47,    69,   124,   132,
     131,    70,    -1,    48,    69,   124,   214,    70,    -1,     8,
     192,   153,   157,   159,    -1,     7,   137,   153,   158,   159,
      -1,     7,    87,   153,   158,   159,    -1,   137,   209,    -1,
     137,    68,   209,    -1,   209,    -1,     9,   153,   157,    -1,
     101,    -1,    60,    -1,    50,   152,   158,    -1,    50,    73,
     144,    74,   157,    -1,    50,    56,    73,   141,    74,    -1,
     178,    -1,    17,   101,    73,   178,    74,    -1,    17,   209,
      73,   194,    74,    -1,   194,    -1,   142,    -1,   144,   143,
      -1,   143,    -1,    51,   152,   158,    -1,    51,    73,   144,
      74,   157,    -1,    51,    56,    73,   141,    74,    -1,    52,
     101,    50,    73,   144,    74,    51,    73,   144,    74,   158,
      -1,    52,   101,    50,    73,   144,    74,   158,    -1,    52,
     101,    51,    73,   144,    74,   158,    -1,    52,   101,    51,
      56,    73,   141,    74,    -1,    53,    17,   139,    -1,    53,
      -1,    54,   101,    -1,    54,    55,   101,    -1,    54,    17,
     101,    -1,    54,    55,    17,   101,    -1,    57,   101,    -1,
      57,    55,   101,    -1,    57,    17,   101,    -1,    57,    55,
      17,   101,    -1,   150,   101,    -1,   101,    -1,    58,   150,
      -1,    58,   150,    59,   139,    -1,   153,     4,   154,    -1,
     153,     4,   155,    -1,   152,    -1,    -1,   156,    -1,    18,
     156,    -1,   230,    -1,     5,   172,    -1,   172,    -1,   157,
      -1,    -1,   162,   165,   167,   166,    -1,   160,   161,    -1,
     161,    -1,   223,    -1,   188,    -1,    69,   214,    62,   210,
      70,    -1,   210,    -1,    40,    22,   160,    -1,    -1,   186,
      -1,   164,   163,    -1,   163,    -1,    41,   164,    -1,    -1,
     170,   171,    -1,   171,   170,    -1,   170,    -1,   171,    -1,
      -1,    21,    22,   168,    -1,    -1,   168,   169,    -1,   169,
      -1,    24,   222,    -1,    25,   222,    -1,   188,    -1,   210,
      -1,   222,    -1,   223,    -1,    12,    94,    -1,    20,    94,
      -1,    73,   173,   174,    74,    -1,   178,    -1,    -1,   174,
     175,    -1,   175,    -1,    -1,   176,   177,   173,    -1,   179,
      -1,   185,    -1,   108,    -1,    -1,   195,   108,   173,    -1,
     195,    -1,   180,    -1,   182,    -1,   181,    -1,   184,    -1,
       6,   172,    -1,    17,   209,   172,    -1,   172,    13,   183,
      -1,   172,    -1,   183,    13,   172,    -1,   172,    -1,    67,
      69,   210,    89,   214,    70,    -1,    19,   186,    -1,   222,
      -1,   223,    -1,   188,    -1,   107,    -1,    -1,   230,    69,
     124,   191,   187,    70,    -1,   225,   191,    70,    -1,    61,
     190,    -1,    69,   191,    70,    -1,   191,    68,   214,    -1,
     214,    -1,    -1,    73,   193,    74,    -1,   194,    -1,    -1,
     195,   108,   193,    -1,   195,    -1,   208,   196,    -1,   203,
     198,    -1,   202,   199,   197,    -1,   107,   198,    -1,    -1,
     196,    -1,    -1,   201,   200,    -1,    68,   199,    -1,    -1,
     207,    -1,   209,    -1,    27,    -1,   205,    -1,   204,    -1,
      71,   196,    72,    -1,    69,   206,    70,    -1,   206,   207,
      -1,   207,    -1,   208,    -1,   203,    -1,   210,    -1,   213,
      -1,   210,    -1,   230,    -1,    75,   211,    -1,    76,   211,
      -1,   106,    -1,    75,   211,    -1,    76,   211,    -1,   211,
      -1,   230,    -1,    90,    -1,   226,    -1,   100,    -1,   231,
      -1,    69,    70,    -1,   215,    -1,   215,    77,   216,    -1,
     216,    -1,   216,    78,   217,    -1,   217,    -1,   218,    79,
     218,    -1,   218,    80,   218,    -1,   218,    81,   218,    -1,
     218,    82,   218,    -1,   218,    83,   218,    -1,   218,    84,
     218,    -1,   218,    65,   190,    -1,   218,    64,    65,   190,
      -1,   218,    -1,   219,    85,   218,    -1,   219,    86,   218,
      -1,   219,   228,    -1,   219,   229,    -1,   219,    -1,   220,
      87,   219,    -1,   220,    88,   219,    -1,   220,    -1,   109,
     221,    -1,    85,   221,    -1,    86,   221,    -1,   221,    -1,
     222,    -1,   223,    -1,   188,    -1,   213,    -1,   210,    -1,
     123,    -1,    69,   214,    70,    -1,    30,    69,   214,    70,
      -1,    34,    69,   214,    70,    -1,    26,    69,   214,    68,
     214,    70,    -1,    35,    69,   214,    70,    -1,    16,    69,
     210,    70,    -1,    31,    69,   214,    70,    -1,    32,    69,
     214,    70,    -1,    33,    69,   214,    70,    -1,    33,    69,
      70,    -1,   189,    -1,    63,    69,   214,    68,   214,    68,
     214,    70,    -1,    28,    69,   214,    68,   214,    70,    -1,
      29,    69,   214,    68,   214,    70,    -1,    39,    69,   214,
      68,   214,    70,    -1,    36,    69,   214,    70,    -1,    37,
      69,   214,    70,    -1,    38,    69,   214,    70,    -1,   224,
      -1,    23,    69,   214,    68,   214,    70,    -1,    23,    69,
     214,    68,   214,    68,   214,    70,    -1,   102,    -1,   104,
      -1,   227,    -1,   228,    -1,   229,    -1,    94,    -1,    97,
      -1,    91,    -1,    95,    -1,    98,    -1,    92,    -1,    96,
      -1,    99,    -1,    93,    -1,   101,    -1,   103,    -1,   105,
      -1,    71,    72,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   371,   371,   377,   389,   396,   401,   406,   411,   415,
     419,   420,   424,   428,   432,   436,   440,   444,   448,   456,
     464,   469,   476,   506,   513,   520,   527,   539,   543,   554,
     563,   572,   596,   600,   640,   644,   648,   652,   656,   660,
     664,   671,   682,   688,   692,   700,   720,   740,   760,   780,
     800,   805,   814,   823,   844,   871,   892,   902,   908,   918,
     927,   936,   957,   966,   970,   978,   992,  1021,  1043,  1059,
    1079,  1094,  1101,  1109,  1122,  1146,  1160,  1187,  1205,  1227,
    1248,  1269,  1290,  1314,  1346,  1370,  1394,  1422,  1454,  1478,
    1503,  1531,  1563,  1572,  1596,  1626,  1662,  1663,  1666,  1667,
    1671,  1687,  1703,  1711,  1715,  1723,  1728,  1735,  1740,  1750,
    1775,  1779,  1783,  1803,  1817,  1831,  1836,  1843,  1853,  1878,
    1893,  1898,  1899,  1900,  1901,  1903,  1909,  1917,  1922,  1932,
    1957,  1964,  1971,  1979,  1996,  2004,  2016,  2032,  2050,  2108,
    2122,  2134,  2171,  2176,  2188,  2236,  2249,  2277,  2278,  2283,
    2314,  2322,  2326,  2330,  2334,  2342,  2386,  2441,  2456,  2463,
    2473,  2503,  2524,  2532,  2536,  2540,  2547,  2552,  2559,  2603,
    2642,  2671,  2678,  2688,  2710,  2717,  2725,  2730,  2746,  2781,
    2796,  2840,  2888,  2991,  2996,  3003,  3008,  3015,  3098,  3103,
    3110,  3118,  3128,  3160,  3164,  3172,  3239,  3371,  3429,  3471,
    3475,  3483,  3495,  3508,  3514,  3522,  3526,  3533,  3543,  3547,
    3551,  3561,  3565,  3569,  3573,  3577,  3581,  3591,  3599,  3606,
    3614,  3622,  3631,  3638,  3645,  3652,  3659,  3666,  3673,  3678,
    3683,  3692,  3699,  3706,  3719,  3732,  3739,  3746,  3753,  3761,
    3768,  3772,  3779,  3793,  3797,  3801,  3810,  3816,  3826,  3834,
    3842,  3849,  3856,  3863,  3870,  3885,  3892,  3899,  3906,  3913,
    3917,  3924,  3931,  3938,  3945,  3952,  3959,  3966,  3974,  3981,
    3995,  4001,  4021,  4025,  4029,  4036,  4040,  4044,  4052,  4056,
    4060,  4068,  4072,  4076,  4088,  4094,  4114,  4120
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SELECT", "FROM", "WHERE", "OPTIONAL",
  "DESCRIBE", "CONSTRUCT", "ASK", "DISTINCT", "REDUCED", "LIMIT", "UNION",
  "PREFIX", "BASE", "BOUND", "GRAPH", "NAMED", "FILTER", "OFFSET", "ORDER",
  "BY", "REGEX", "ASC", "DESC", "LANGMATCHES", "\"a\"", "\"strlang\"",
  "\"strdt\"", "\"str\"", "\"iri\"", "\"uri\"", "\"bnode\"", "\"lang\"",
  "\"datatype\"", "\"isUri\"", "\"isBlank\"", "\"isLiteral\"",
  "\"sameTerm\"", "GROUP", "HAVING", "COUNT", "SUM", "AVG", "MIN", "MAX",
  "GROUP_CONCAT", "SAMPLE", "SEPARATOR", "DELETE", "INSERT", "WITH",
  "CLEAR", "CREATE", "SILENT", "DATA", "DROP", "LOAD", "INTO", "DEFAULT",
  "COALESCE", "AS", "IF", "NOT", "IN", "EXPLAIN", "LET", "','", "'('",
  "')'", "'['", "']'", "'{'", "'}'", "'?'", "'$'", "SC_OR", "SC_AND", "EQ",
  "NEQ", "LT", "GT", "LE", "GE", "'+'", "'-'", "'*'", "'/'", "\":=\"",
  "\"string literal\"", "\"double literal\"",
  "\"double positive literal\"", "\"double negative literal\"",
  "\"integer literal\"", "\"integer positive literal\"",
  "\"integer negative literal\"", "\"decimal literal\"",
  "\"decimal positive literal\"", "\"decimal negative literal\"",
  "\"boolean literal\"", "\"URI literal\"", "\"URI literal (\"",
  "\"QName literal\"", "\"QName literal (\"", "\"blank node literal\"",
  "\"identifier\"", "';'", "'.'", "'!'", "$accept", "Query", "ExplainOpt",
  "ReportFormat", "UpdateOperationList", "UpdateOperation", "Prologue",
  "BaseDeclOpt", "PrefixDeclListOpt", "SelectQuery",
  "SelectExpressionList", "SelectExpressionListTail", "SelectTerm",
  "AggregateExpression", "DistinctOpt", "ExpressionOrStar",
  "CountAggregateExpression", "SumAggregateExpression",
  "AvgAggregateExpression", "MinAggregateExpression",
  "MaxAggregateExpression", "SeparatorOpt", "ExpressionList",
  "GroupConcatAggregateExpression", "SampleAggregateExpression",
  "ConstructQuery", "DescribeQuery", "VarOrIRIrefList", "AskQuery",
  "GraphRef", "DeleteQuery", "GraphTriples", "GraphTemplate",
  "ModifyTemplate", "ModifyTemplateList", "InsertQuery", "UpdateQuery",
  "ClearQuery", "CreateQuery", "DropQuery", "IriRefList", "LoadQuery",
  "DatasetClauseList", "DatasetClauseListOpt", "DefaultGraphClause",
  "NamedGraphClause", "SourceSelector", "WhereClause", "WhereClauseOpt",
  "SolutionModifier", "GroupConditionList", "GroupCondition",
  "GroupClauseOpt", "HavingCondition", "HavingConditionList",
  "HavingClauseOpt", "LimitOffsetClausesOpt", "OrderClauseOpt",
  "OrderConditionList", "OrderCondition", "LimitClause", "OffsetClause",
  "GroupGraphPattern", "TriplesBlockOpt", "GraphPatternListOpt",
  "GraphPatternList", "GraphPatternListFilter", "DotOptional",
  "TriplesBlock", "GraphPatternNotTriples", "OptionalGraphPattern",
  "GraphGraphPattern", "GroupOrUnionGraphPattern",
  "GroupOrUnionGraphPatternList", "LetGraphPattern", "Filter",
  "Constraint", "ParamsOpt", "FunctionCall", "CoalesceExpression",
  "ArgList", "ArgListNoBraces", "ConstructTemplate", "ConstructTriplesOpt",
  "ConstructTriples", "TriplesSameSubject", "PropertyListNotEmpty",
  "PropertyListTailOpt", "PropertyList", "ObjectList", "ObjectTail",
  "Object", "Verb", "TriplesNode", "BlankNodePropertyList", "Collection",
  "GraphNodeListNotEmpty", "GraphNode", "VarOrTerm", "VarOrIRIref", "Var",
  "VarName", "VarOrBadVarName", "GraphTerm", "Expression",
  "ConditionalOrExpression", "ConditionalAndExpression",
  "RelationalExpression", "AdditiveExpression", "MultiplicativeExpression",
  "UnaryExpression", "PrimaryExpression", "BrackettedExpression",
  "BuiltInCall", "RegexExpression", "IRIrefBrace", "NumericLiteral",
  "NumericLiteralUnsigned", "NumericLiteralPositive",
  "NumericLiteralNegative", "IRIref", "BlankNode", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,    44,    40,
      41,    91,    93,   123,   125,    63,    36,   323,   324,   325,
     326,   327,   328,   329,   330,    43,    45,    42,    47,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,    59,    46,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   110,   111,   112,   112,   113,   113,   113,   113,   113,
     114,   114,   115,   115,   115,   115,   115,   115,   115,   116,
     117,   117,   118,   118,   119,   119,   119,   120,   120,   121,
     121,   121,   122,   122,   123,   123,   123,   123,   123,   123,
     123,   124,   124,   125,   125,   126,   127,   128,   129,   130,
     131,   131,   132,   132,   133,   134,   135,   136,   136,   137,
     137,   137,   138,   139,   139,   140,   140,   140,   141,   141,
     142,   143,   143,   144,   144,   145,   145,   145,   146,   146,
     146,   146,   147,   147,   148,   148,   148,   148,   149,   149,
     149,   149,   150,   150,   151,   151,   152,   152,   153,   153,
     154,   155,   156,   157,   157,   158,   158,   159,   160,   160,
     161,   161,   161,   161,   162,   162,   163,   164,   164,   165,
     165,   166,   166,   166,   166,   166,   167,   167,   168,   168,
     169,   169,   169,   169,   169,   169,   170,   171,   172,   173,
     173,   174,   174,   174,   175,   176,   176,   177,   177,   178,
     178,   179,   179,   179,   179,   180,   181,   182,   182,   183,
     183,   184,   185,   186,   186,   186,   187,   187,   188,   188,
     189,   190,   191,   191,   191,   192,   193,   193,   194,   194,
     195,   195,   196,   197,   197,   198,   198,   199,   200,   200,
     201,   202,   202,   203,   203,   204,   205,   206,   206,   207,
     207,   208,   208,   209,   209,   210,   210,   211,   212,   212,
     212,   213,   213,   213,   213,   213,   213,   214,   215,   215,
     216,   216,   217,   217,   217,   217,   217,   217,   217,   217,
     217,   218,   218,   218,   218,   218,   219,   219,   219,   220,
     220,   220,   220,   221,   221,   221,   221,   221,   221,   222,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   224,   224,
     225,   225,   226,   226,   226,   227,   227,   227,   228,   228,
     228,   229,   229,   229,   230,   230,   231,   231
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     1,     0,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     4,     0,     6,     6,     5,     1,     1,     2,
       3,     1,     1,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     5,     5,     5,     5,     5,
       4,     0,     3,     1,     6,     5,     5,     5,     5,     2,
       3,     1,     3,     1,     1,     3,     5,     5,     1,     5,
       5,     1,     1,     2,     1,     3,     5,     5,    11,     7,
       7,     7,     3,     1,     2,     3,     3,     4,     2,     3,
       3,     4,     2,     1,     2,     4,     3,     3,     1,     0,
       1,     2,     1,     2,     1,     1,     0,     4,     2,     1,
       1,     1,     5,     1,     3,     0,     1,     2,     1,     2,
       0,     2,     2,     1,     1,     0,     3,     0,     2,     1,
       2,     2,     1,     1,     1,     1,     2,     2,     4,     1,
       0,     2,     1,     0,     3,     1,     1,     1,     0,     3,
       1,     1,     1,     1,     1,     2,     3,     3,     1,     3,
       1,     6,     2,     1,     1,     1,     1,     0,     6,     3,
       2,     3,     3,     1,     0,     3,     1,     0,     3,     1,
       2,     2,     3,     2,     0,     1,     0,     2,     2,     0,
       1,     1,     1,     1,     1,     3,     3,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     2,     1,     3,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     4,
       1,     3,     3,     2,     2,     1,     3,     3,     1,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       4,     4,     6,     4,     4,     4,     4,     4,     3,     1,
       8,     6,     6,     6,     4,     4,     4,     1,     6,     8,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      21,     0,     0,     4,    23,    20,     1,     3,     0,    19,
       0,     0,     0,    99,    99,    99,     0,    83,     0,     0,
       0,     2,     9,    11,     5,     6,     7,     8,    12,    13,
      14,    15,    16,    17,    18,     0,     0,     0,     0,     0,
       0,    28,    99,    27,    31,    32,    99,   284,   285,    99,
      61,   203,   204,   177,    99,    98,     0,     0,     0,   106,
       0,     0,     0,   106,     0,     0,     0,     0,    84,     0,
       0,    88,    93,    94,    10,     0,    99,    99,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   212,   277,   280,   283,
     275,   278,   281,   276,   279,   282,   214,   270,   271,   286,
       0,   248,    34,    35,    36,    37,    38,    39,    40,   245,
     259,   247,   246,     0,   217,   219,   221,   230,   235,   238,
     242,   243,   244,   267,   174,   213,   272,   273,   274,   211,
     215,   207,   205,   206,     0,     0,    29,   106,     0,   106,
      59,     0,     0,     0,   176,   179,   186,   194,   193,     0,
     201,   202,   211,     0,     0,     0,   140,    62,   104,     0,
       0,    72,    74,     0,    71,   105,    65,     0,     0,    75,
       0,     0,    64,    63,    82,    86,     0,    85,    90,     0,
      89,     0,    92,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    42,    42,    42,    42,    42,    42,    42,   174,   170,
       0,   216,     0,   287,   240,   241,   239,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     233,   234,     0,     0,     0,   173,    42,   115,    30,   115,
      60,   115,   200,     0,   198,   199,   192,     0,     0,   191,
     175,   177,   185,   181,   180,   115,     0,    96,    97,   100,
     102,   103,   143,   139,   150,     0,     0,    68,     0,     0,
      73,     0,     0,     0,     0,     0,    87,    91,    95,   115,
     115,     0,     0,     0,     0,     0,     0,     0,     0,   258,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   249,     0,     0,
     210,     0,   218,   220,     0,   228,   222,   223,   224,   225,
     226,   227,   231,   232,   236,   237,     0,   169,   174,     0,
      26,   120,    58,    57,   196,   197,   195,   184,   189,   190,
     178,    56,   101,     0,     0,     0,     0,   158,     0,   142,
     148,   145,   151,   153,   152,   154,   146,   140,     0,    67,
       0,    66,    77,    76,     0,     0,     0,    24,    25,   254,
       0,     0,     0,     0,   250,   255,   256,   257,   251,   253,
     264,   265,   266,     0,    44,     0,    43,     0,     0,     0,
       0,    51,    53,     0,   171,     0,   208,   209,    33,   229,
     172,   167,     0,     0,   127,   186,   182,     0,   187,   155,
       0,     0,   162,   165,   163,   164,     0,     0,     0,   138,
     141,   147,   140,   149,     0,     0,   106,     0,   106,     0,
       0,     0,     0,     0,    45,    46,    47,    48,    49,     0,
       0,     0,    55,     0,   166,     0,     0,   114,   109,   111,
     113,   110,   118,   119,   116,     0,   125,   183,   188,   156,
       0,   160,   157,   144,     0,    70,     0,    79,    81,    80,
       0,   268,   252,   261,   262,   263,    52,     0,    54,     0,
     168,     0,   108,   117,     0,     0,     0,   107,   123,   124,
       0,     0,    69,     0,     0,     0,     0,     0,     0,     0,
     126,   129,   132,   133,   134,   135,   136,   137,   121,   122,
       0,   159,     0,   269,    50,   260,     0,   130,   131,   128,
     161,   106,   112,    78
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     8,    21,    22,    23,     3,     4,     9,    24,
      42,    43,    44,   121,   318,   405,   122,   123,   124,   125,
     126,   461,   411,   127,   128,    25,    26,    49,    27,   194,
      28,   286,   181,   182,   183,    29,    30,    31,    32,    33,
      73,    34,    55,    60,   277,   278,   279,   185,   186,   350,
     467,   468,   351,   472,   473,   424,   507,   476,   520,   521,
     508,   509,   178,   282,   368,   369,   370,   442,   283,   371,
     372,   373,   374,   482,   375,   376,   474,   465,   129,   130,
     229,   254,    54,   163,   184,   165,   272,   426,   273,   357,
     428,   358,   268,   166,   167,   168,   263,   359,   169,   269,
     131,   152,   331,   132,   255,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -340
static const yytype_int16 yypact[] =
{
      29,   -51,    54,    -1,  -340,  -340,  -340,  -340,   293,    70,
     151,   189,    15,  -340,    -9,     2,     0,   114,    13,    14,
      34,  -340,   368,  -340,  -340,  -340,  -340,  -340,  -340,  -340,
    -340,  -340,  -340,  -340,  -340,    51,   197,   197,  1017,    77,
      77,  -340,  -340,   280,  -340,  -340,  -340,  -340,  -340,    71,
    -340,  -340,  -340,  1445,  -340,  -340,    36,    69,   380,    57,
     159,   118,   380,    57,    27,   -14,    94,    18,  -340,   103,
      19,  -340,  -340,   -31,  -340,   107,  -340,  -340,   155,   168,
     200,   202,   205,   209,   220,   224,   226,   242,   248,   252,
     255,   259,   260,   262,   263,   264,   269,   271,   273,   283,
     288,   289,   557,   176,  1107,  1107,  -340,  -340,  -340,  -340,
    -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,
    1107,  -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,
    -340,  -340,  -340,   297,   284,   287,  -340,   299,   227,    92,
    -340,  -340,  -340,  -340,  1017,  -340,  -340,  -340,  -340,   300,
    -340,  -340,  -340,  -340,    36,   175,  -340,    36,   156,    36,
    -340,  1375,    22,   292,  -340,   254,    52,  -340,  -340,    52,
    -340,  -340,  -340,    36,     5,   295,  1445,  -340,  -340,  1338,
     156,  -340,  -340,   694,  -340,  -340,  -340,  1338,   731,  -340,
     298,     7,  -340,  -340,  -340,  -340,   272,  -340,  -340,   285,
    -340,   -14,  -340,  -340,    36,    36,   125,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,   837,  1017,  1017,  1017,  1017,  1017,
    1017,   362,   362,   362,   362,   362,   362,   362,  1017,  -340,
    1017,  -340,   314,  -340,  -340,  -340,  -340,    -2,  1017,  1017,
     320,   288,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    -340,  -340,  1017,  1017,    90,  -340,   362,   353,  -340,   353,
    -340,   353,  -340,  1412,  -340,  -340,  -340,   323,  1445,  -340,
    -340,  1445,  -340,  -340,  -340,   353,   116,  -340,  -340,  -340,
    -340,  -340,   169,  -340,   290,   301,   322,  -340,   326,    37,
    -340,   327,    37,   380,   331,   380,  -340,  -340,  -340,   353,
     353,   335,   338,   342,   343,   345,   344,   346,   354,  -340,
     358,   359,   360,   361,   363,   373,   355,  -340,   927,  1017,
    1017,  1017,  1017,  1017,  1017,   179,   376,  -340,    77,    77,
    -340,   377,   287,  -340,   288,  -340,  -340,  -340,  -340,  -340,
    -340,  -340,  -340,  -340,  -340,  -340,  1017,  -340,  1017,   430,
    -340,   417,  -340,  -340,  -340,  -340,  -340,   357,   391,  -340,
    -340,  -340,  -340,   295,   156,  1248,   392,   447,    76,  -340,
     378,  -340,  -340,  -340,  -340,  -340,  -340,  1445,   389,  -340,
    1445,  -340,  -340,  -340,  1239,  1338,  1272,  -340,  -340,  -340,
    1017,  1017,  1017,  1017,  -340,  -340,  -340,  -340,  -340,  -340,
    -340,  -340,  -340,  1017,  -340,   396,  -340,   398,   399,   418,
     419,   -11,  -340,   421,  -340,  1017,  -340,  -340,  -340,  -340,
    -340,    -8,  1197,  1248,   466,    52,  -340,  1445,  -340,  -340,
     295,  1017,  -340,  -340,  -340,  -340,   300,   125,   295,  -340,
    -340,  -340,  1445,  -340,  1445,   423,    32,   424,    37,   186,
     422,   425,   429,   431,  -340,  -340,  -340,  -340,  -340,  1017,
     444,   432,  -340,   436,  -340,   435,  1017,  1197,  -340,  -340,
    -340,  -340,  -340,  1248,  -340,   478,   170,  -340,  -340,  -340,
     420,  -340,   493,  -340,   434,  -340,   438,  -340,  -340,  -340,
    1017,  -340,  -340,  -340,  -340,  -340,  -340,   433,  -340,  1017,
    -340,   451,  -340,  -340,   671,   426,   427,  -340,   494,   503,
    1017,   295,  -340,   380,   446,   428,   449,   125,   448,   448,
     671,  -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,
     453,  -340,  1305,  -340,  -340,  -340,   454,  -340,  -340,  -340,
    -340,    37,  -340,  -340
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -340,  -340,  -340,  -340,  -340,   504,  -340,  -340,  -340,  -340,
     251,  -340,   -23,  -340,    83,  -340,  -340,  -340,  -340,  -340,
    -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,  -340,   324,
    -340,  -169,  -340,  -179,   -60,  -340,  -340,  -340,  -340,  -340,
    -340,  -340,   215,   221,  -340,  -340,   253,   -37,   -57,  -208,
    -340,    61,  -340,    58,  -340,  -340,  -340,  -340,  -340,    10,
      24,    26,  -170,  -339,  -340,   164,  -340,  -340,  -162,  -340,
    -340,  -340,  -340,  -340,  -340,  -340,   172,  -340,  -333,  -340,
    -212,  -207,  -340,   267,   -43,  -163,  -103,  -340,   110,   112,
    -340,  -340,  -340,  -150,  -340,  -340,  -340,  -139,  -147,    -4,
     -10,   -25,  -340,   -50,   352,  -340,   302,   303,   193,    62,
    -340,   -49,  -279,  -258,  -340,  -340,  -340,  -340,   403,   406,
      23,  -340
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -99
static const yytype_int16 yytable[] =
{
      45,    51,   188,   171,   290,   281,   189,    50,   171,   290,
     164,   262,   171,   284,   265,   153,   284,   287,   291,   177,
     156,   325,   264,   276,   284,   287,    45,    45,   201,   335,
      66,    69,   433,    45,    52,   196,   199,   175,   443,    51,
     174,   175,   175,   170,     1,   160,   192,    57,   170,   266,
       5,   352,   170,   353,     6,   234,   235,   459,    61,   267,
     346,   -98,   175,   294,    58,     7,   274,   361,    67,    70,
     202,   236,    52,   328,   329,    62,   172,   190,   191,   266,
     295,   172,   363,   486,    35,   172,   434,   193,    53,   469,
     433,   387,   388,   364,   233,   365,   460,    39,    40,   464,
     259,    64,   261,   483,   151,   176,    47,   435,    48,   176,
     176,   171,   367,   262,    68,    71,   265,   257,   262,   197,
     200,   265,   419,    47,   355,    48,   171,    39,    40,   171,
     176,    65,   258,   171,   469,    72,   275,   171,   171,   158,
     433,   421,   179,   366,   434,    45,    39,    40,    51,   176,
     439,   170,    51,    47,   260,    48,    51,    75,   346,    51,
     347,    36,    37,   174,   471,   435,   170,   299,   300,   170,
      51,   522,    47,   170,    48,   363,   288,   170,   170,   252,
     253,    52,   505,   151,   172,    52,   364,   522,   365,    52,
     506,   187,    52,   429,   434,   195,   301,   280,   367,   172,
      39,    40,   172,    52,   198,   290,   172,   290,   203,   471,
     172,   172,   330,   171,   284,   435,   447,    47,   171,    48,
      38,   171,   284,   287,   206,   524,    39,    40,   164,    59,
      63,    39,    40,   384,    56,   386,   366,   207,    41,   537,
     538,   524,   176,   171,    38,   171,   525,   346,   233,   414,
      39,    40,   381,   170,   490,   383,   491,    47,   170,    48,
     479,   170,   525,   154,    39,    40,    38,   157,   481,   208,
     159,   209,    39,    40,   210,   173,    46,   262,   211,   284,
     265,   284,   484,   170,    41,   170,   172,    76,    77,   212,
      47,   172,    48,   213,   172,   214,    10,   204,   205,   280,
      11,    12,    13,   416,   417,   319,   320,   321,   322,   323,
     324,   215,   248,   249,   344,   345,   172,   216,   172,   108,
     109,   217,   111,   112,   218,   114,   115,   171,   219,   220,
     171,   221,   222,   223,   171,   171,   171,   445,   224,   348,
     225,   531,   226,    14,    15,    16,    17,    18,   155,    38,
      19,    20,   227,   290,    51,    39,    40,   228,   230,   237,
     430,   238,   271,   240,   241,   239,   270,   170,   176,   256,
     170,   293,   317,   296,   170,   170,   170,   171,   242,   243,
     244,   245,   246,   247,   327,   334,   297,    52,   436,   487,
     133,   489,   171,   349,   171,   356,   379,   180,   377,   380,
     172,   382,   378,   172,   385,   389,   390,   172,   172,   172,
     391,   392,   470,   393,   394,    51,   395,   170,    14,    15,
      16,    17,    18,   403,   396,    19,    20,   480,   397,   398,
     399,   400,   170,   401,   170,   336,   337,   338,   339,   340,
     341,   342,   343,   402,   415,   436,   436,   418,    52,   161,
     172,   162,   422,   532,   232,    39,    40,   470,   423,   427,
     438,   437,   444,   171,   425,   172,   454,   172,   455,   456,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,    47,   171,    48,   543,   119,   441,   475,   457,   458,
     436,   462,   492,   497,   523,   493,   436,   485,   488,   494,
     504,   495,   498,   170,   499,   500,   511,   536,   512,   510,
     523,   513,   515,   517,   506,   505,   533,   431,   534,   535,
     526,   527,   170,   540,   542,   298,    74,   436,   502,   362,
     539,   503,   440,   529,   528,   477,   172,   432,   360,   478,
     332,   250,   333,   436,   251,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   172,     0,     0,     0,   302,
     303,   304,   305,   306,   307,   308,   310,   311,   312,   313,
     314,   315,   316,    78,     0,     0,     0,     0,     0,     0,
      79,     0,   326,    80,     0,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,     0,
     101,     0,     0,     0,     0,     0,   102,   231,   103,     0,
       0,     0,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,    47,   117,
      48,   118,   119,     0,     0,     0,   120,     0,     0,     0,
     406,   407,   408,   409,   410,   412,   413,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,     0,     0,
       0,     0,     0,     0,    79,   518,   519,    80,   420,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,   180,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   100,     0,   101,     0,     0,     0,     0,     0,
     431,     0,   449,   450,   451,   452,    39,    40,   180,     0,
       0,     0,     0,     0,     0,   453,     0,     0,     0,     0,
       0,     0,     0,   161,     0,   162,     0,   463,   289,    39,
      40,     0,    47,   117,    48,   118,     0,     0,     0,     0,
       0,     0,     0,   232,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,    47,     0,    48,     0,   119,
     161,     0,   162,     0,     0,   292,    39,    40,     0,     0,
       0,   496,     0,     0,     0,     0,     0,     0,   501,     0,
       0,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,    47,     0,    48,     0,   119,     0,     0,     0,
       0,     0,   514,     0,     0,     0,     0,     0,     0,     0,
       0,   516,     0,    78,     0,     0,     0,     0,     0,     0,
      79,     0,   530,    80,     0,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,     0,
     101,     0,     0,     0,     0,     0,   102,   309,   103,     0,
       0,     0,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,    47,   117,
      48,   118,   119,    78,     0,     0,   120,     0,     0,     0,
      79,     0,     0,    80,     0,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,     0,
     101,     0,     0,     0,     0,     0,   102,     0,   103,     0,
       0,     0,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   404,     0,     0,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,    47,   117,
      48,   118,   119,    78,     0,     0,   120,     0,     0,     0,
      79,     0,     0,    80,     0,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,     0,
     101,     0,     0,     0,     0,     0,   102,     0,   103,     0,
       0,     0,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,    47,   117,
      48,   118,   119,    78,     0,     0,   120,     0,     0,     0,
      79,     0,     0,    80,     0,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,     0,     0,    93,
      94,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,     0,
     101,     0,     0,     0,     0,     0,   102,     0,   103,     0,
       0,     0,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,    47,   117,
      48,   118,   119,    78,     0,     0,     0,     0,     0,     0,
      79,     0,     0,    80,     0,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   180,     0,   100,     0,
     101,     0,     0,     0,    78,     0,   466,     0,     0,     0,
       0,    79,    39,    40,    80,     0,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,     0,   180,
       0,     0,     0,     0,     0,     0,     0,     0,    47,   117,
      48,   118,     0,     0,     0,     0,     0,     0,   161,   100,
     162,   101,     0,   446,    39,    40,     0,   431,     0,     0,
       0,     0,   180,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
      47,   161,    48,   162,   119,     0,   448,    39,    40,    47,
     117,    48,   118,     0,     0,   285,     0,     0,     0,     0,
       0,     0,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,    47,   161,    48,   162,   119,     0,   541,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,    47,   161,    48,   162,
     119,     0,     0,    39,    40,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,    47,
       0,    48,     0,   119,   161,   231,   162,     0,     0,     0,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,    47,     0,    48,     0,
     119,   161,   354,   162,     0,     0,     0,    39,    40,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,    47,   161,    48,   162,   119,     0,     0,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,    47,     0,    48,     0,
     119
};

static const yytype_int16 yycheck[] =
{
      10,    11,    62,    53,   183,   175,    63,    11,    58,   188,
      53,   161,    62,   176,   161,    40,   179,   179,   187,    56,
      43,   228,   161,    18,   187,   187,    36,    37,    59,   241,
      17,    17,   365,    43,    11,    17,    17,     5,   377,    49,
       4,     5,     5,    53,    15,    49,    60,    56,    58,    27,
     101,   259,    62,   261,     0,   104,   105,    68,    56,   162,
      68,     4,     5,    56,    73,    66,   169,   275,    55,    55,
     101,   120,    49,    75,    76,    73,    53,    50,    51,    27,
      73,    58,     6,    51,    14,    62,   365,   101,    73,   422,
     423,   299,   300,    17,    72,    19,   107,    75,    76,   107,
     157,   101,   159,   442,   106,    73,   101,   365,   103,    73,
      73,   161,   282,   263,   101,   101,   263,   154,   268,   101,
     101,   268,   334,   101,   263,   103,   176,    75,    76,   179,
      73,    17,   155,   183,   467,   101,   173,   187,   188,    68,
     473,   348,    73,    67,   423,   155,    75,    76,   158,    73,
      74,   161,   162,   101,   158,   103,   166,   106,    68,   169,
      70,    10,    11,     4,   422,   423,   176,   204,   205,   179,
     180,   504,   101,   183,   103,     6,   180,   187,   188,    87,
      88,   158,    12,   106,   161,   162,    17,   520,    19,   166,
      20,    73,   169,   363,   473,   101,   206,   174,   368,   176,
      75,    76,   179,   180,   101,   384,   183,   386,   101,   467,
     187,   188,   237,   263,   377,   473,   385,   101,   268,   103,
      69,   271,   385,   385,    69,   504,    75,    76,   271,    14,
      15,    75,    76,   293,    13,   295,    67,    69,    87,   518,
     519,   520,    73,   293,    69,   295,   504,    68,    72,    70,
      75,    76,   289,   263,    68,   292,    70,   101,   268,   103,
     430,   271,   520,    42,    75,    76,    69,    46,   438,    69,
      49,    69,    75,    76,    69,    54,    87,   427,    69,   442,
     427,   444,   444,   293,    87,   295,   263,    36,    37,    69,
     101,   268,   103,    69,   271,    69,     3,    76,    77,   276,
       7,     8,     9,   328,   329,   222,   223,   224,   225,   226,
     227,    69,    85,    86,   252,   253,   293,    69,   295,    92,
      93,    69,    95,    96,    69,    98,    99,   377,    69,    69,
     380,    69,    69,    69,   384,   385,   386,   380,    69,   256,
      69,   511,    69,    50,    51,    52,    53,    54,    68,    69,
      57,    58,    69,   532,   364,    75,    76,    69,    69,    62,
     364,    77,   108,    64,    65,    78,    74,   377,    73,    69,
     380,    73,    10,   101,   384,   385,   386,   427,    79,    80,
      81,    82,    83,    84,    70,    65,   101,   364,   365,   446,
      38,   448,   442,    40,   444,    72,    74,    17,   108,    73,
     377,    74,   101,   380,    73,    70,    68,   384,   385,   386,
      68,    68,   422,    68,    70,   425,    70,   427,    50,    51,
      52,    53,    54,    68,    70,    57,    58,   437,    70,    70,
      70,    70,   442,    70,   444,   242,   243,   244,   245,   246,
     247,   248,   249,    70,    68,   422,   423,    70,   425,    69,
     427,    71,    22,   513,   102,    75,    76,   467,    41,    68,
      13,    69,    73,   513,   107,   442,    70,   444,    70,    70,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   532,   103,   541,   105,   108,    21,    70,    70,
     467,    70,    70,    49,   504,    70,   473,    74,    74,    70,
      22,    70,    70,   513,    68,    70,    13,   517,    74,    89,
     520,    73,    79,    62,    20,    12,    70,    69,    90,    70,
      94,    94,   532,    70,    70,   201,    22,   504,   467,   276,
     520,   473,   368,   509,   508,   425,   513,   365,   271,   427,
     238,   138,   239,   520,   138,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   532,    -1,    -1,    -1,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,    16,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,   230,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    42,
      43,    44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      63,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,    -1,
      -1,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    86,    -1,    -1,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,    -1,    -1,   109,    -1,    -1,    -1,
     318,   319,   320,   321,   322,   323,   324,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,   346,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,
      69,    -1,   390,   391,   392,   393,    75,    76,    17,    -1,
      -1,    -1,    -1,    -1,    -1,   403,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    69,    -1,    71,    -1,   415,    74,    75,
      76,    -1,   101,   102,   103,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   431,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,    -1,   105,
      69,    -1,    71,    -1,    -1,    74,    75,    76,    -1,    -1,
      -1,   459,    -1,    -1,    -1,    -1,    -1,    -1,   466,    -1,
      -1,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,    -1,   105,    -1,    -1,    -1,
      -1,    -1,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   499,    -1,    16,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,   510,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    42,
      43,    44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      63,    -1,    -1,    -1,    -1,    -1,    69,    70,    71,    -1,
      -1,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    86,    -1,    -1,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    16,    -1,    -1,   109,    -1,    -1,    -1,
      23,    -1,    -1,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    42,
      43,    44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      63,    -1,    -1,    -1,    -1,    -1,    69,    -1,    71,    -1,
      -1,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    86,    87,    -1,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    16,    -1,    -1,   109,    -1,    -1,    -1,
      23,    -1,    -1,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    42,
      43,    44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      63,    -1,    -1,    -1,    -1,    -1,    69,    -1,    71,    -1,
      -1,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    86,    -1,    -1,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    16,    -1,    -1,   109,    -1,    -1,    -1,
      23,    -1,    -1,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    42,
      43,    44,    45,    46,    47,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,
      63,    -1,    -1,    -1,    -1,    -1,    69,    -1,    71,    -1,
      -1,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    16,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    -1,    -1,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    -1,    61,    -1,
      63,    -1,    -1,    -1,    16,    -1,    69,    -1,    -1,    -1,
      -1,    23,    75,    76,    26,    -1,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    17,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,   104,    -1,    -1,    -1,    -1,    -1,    -1,    69,    61,
      71,    63,    -1,    74,    75,    76,    -1,    69,    -1,    -1,
      -1,    -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,    69,   103,    71,   105,    -1,    74,    75,    76,   101,
     102,   103,   104,    -1,    -1,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,    69,   103,    71,   105,    -1,    74,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    69,   103,    71,
     105,    -1,    -1,    75,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,    -1,   105,    69,    70,    71,    -1,    -1,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,    -1,
     105,    69,    70,    71,    -1,    -1,    -1,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,    69,   103,    71,   105,    -1,    -1,
      75,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,    -1,
     105
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    15,   111,   116,   117,   101,     0,    66,   112,   118,
       3,     7,     8,     9,    50,    51,    52,    53,    54,    57,
      58,   113,   114,   115,   119,   135,   136,   138,   140,   145,
     146,   147,   148,   149,   151,    14,    10,    11,    69,    75,
      76,    87,   120,   121,   122,   210,    87,   101,   103,   137,
     209,   210,   230,    73,   192,   152,   153,    56,    73,   152,
     153,    56,    73,   152,   101,    17,    17,    55,   101,    17,
      55,   101,   101,   150,   115,   106,   120,   120,    16,    23,
      26,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    42,    43,    44,    45,    46,    47,    48,
      61,    63,    69,    71,    85,    86,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   102,   104,   105,
     109,   123,   126,   127,   128,   129,   130,   133,   134,   188,
     189,   210,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   106,   211,   211,   153,    68,   122,   153,    68,   153,
     209,    69,    71,   193,   194,   195,   203,   204,   205,   208,
     210,   213,   230,   153,     4,     5,    73,   157,   172,    73,
      17,   142,   143,   144,   194,   157,   158,    73,   144,   158,
      50,    51,    60,   101,   139,   101,    17,   101,   101,    17,
     101,    59,   101,   101,   153,   153,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    69,    69,    69,    69,   190,
      69,    70,   214,    72,   221,   221,   221,    62,    77,    78,
      64,    65,    79,    80,    81,    82,    83,    84,    85,    86,
     228,   229,    87,    88,   191,   214,    69,   157,   122,   158,
     209,   158,   203,   206,   207,   208,    27,   196,   202,   209,
      74,   108,   196,   198,   196,   157,    18,   154,   155,   156,
     230,   172,   173,   178,   195,    17,   141,   178,   209,    74,
     143,   141,    74,    73,    56,    73,   101,   101,   139,   157,
     157,   210,   214,   214,   214,   214,   214,   214,   214,    70,
     214,   214,   214,   214,   214,   214,   214,    10,   124,   124,
     124,   124,   124,   124,   124,   191,   214,    70,    75,    76,
     211,   212,   216,   217,    65,   190,   218,   218,   218,   218,
     218,   218,   218,   218,   219,   219,    68,    70,   124,    40,
     159,   162,   159,   159,    70,   207,    72,   199,   201,   207,
     193,   159,   156,     6,    17,    19,    67,   172,   174,   175,
     176,   179,   180,   181,   182,   184,   185,   108,   101,    74,
      73,   157,    74,   157,   144,    73,   144,   159,   159,    70,
      68,    68,    68,    68,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    68,    87,   125,   214,   214,   214,   214,
     214,   132,   214,   214,    70,    68,   211,   211,    70,   190,
     214,   191,    22,    41,   165,   107,   197,    68,   200,   172,
     209,    69,   186,   188,   222,   223,   230,    69,    13,    74,
     175,   108,   177,   173,    73,   194,    74,   141,    74,   214,
     214,   214,   214,   214,    70,    70,    70,    70,    70,    68,
     107,   131,    70,   214,   107,   187,    69,   160,   161,   188,
     210,   223,   163,   164,   186,    21,   167,   198,   199,   172,
     210,   172,   183,   173,   178,    74,    51,   158,    74,   158,
      68,    70,    70,    70,    70,    70,   214,    49,    70,    68,
      70,   214,   161,   163,    22,    12,    20,   166,   170,   171,
      89,    13,    74,    73,   214,    79,   214,    62,    24,    25,
     168,   169,   188,   210,   222,   223,    94,    94,   171,   170,
     214,   172,   144,    70,    90,    70,   210,   222,   222,   169,
      70,    74,    70,   158
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 90: /* "\"string literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2064 "sparql_parser.c"
	break;
      case 91: /* "\"double literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2076 "sparql_parser.c"
	break;
      case 92: /* "\"double positive literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2088 "sparql_parser.c"
	break;
      case 93: /* "\"double negative literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2100 "sparql_parser.c"
	break;
      case 94: /* "\"integer literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2112 "sparql_parser.c"
	break;
      case 95: /* "\"integer positive literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2124 "sparql_parser.c"
	break;
      case 96: /* "\"integer negative literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2136 "sparql_parser.c"
	break;
      case 97: /* "\"decimal literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2148 "sparql_parser.c"
	break;
      case 98: /* "\"decimal positive literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2160 "sparql_parser.c"
	break;
      case 99: /* "\"decimal negative literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2172 "sparql_parser.c"
	break;
      case 100: /* "\"boolean literal\"" */

/* Line 1000 of yacc.c  */
#line 265 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2184 "sparql_parser.c"
	break;
      case 101: /* "\"URI literal\"" */

/* Line 1000 of yacc.c  */
#line 276 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2196 "sparql_parser.c"
	break;
      case 102: /* "\"URI literal (\"" */

/* Line 1000 of yacc.c  */
#line 276 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2208 "sparql_parser.c"
	break;
      case 103: /* "\"QName literal\"" */

/* Line 1000 of yacc.c  */
#line 282 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2220 "sparql_parser.c"
	break;
      case 104: /* "\"QName literal (\"" */

/* Line 1000 of yacc.c  */
#line 282 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2232 "sparql_parser.c"
	break;
      case 105: /* "\"blank node literal\"" */

/* Line 1000 of yacc.c  */
#line 282 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2244 "sparql_parser.c"
	break;
      case 106: /* "\"identifier\"" */

/* Line 1000 of yacc.c  */
#line 282 "./sparql_parser.y"
	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */
#line 2256 "sparql_parser.c"
	break;
      case 119: /* "SelectQuery" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2268 "sparql_parser.c"
	break;
      case 120: /* "SelectExpressionList" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2280 "sparql_parser.c"
	break;
      case 121: /* "SelectExpressionListTail" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2292 "sparql_parser.c"
	break;
      case 122: /* "SelectTerm" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 2304 "sparql_parser.c"
	break;
      case 123: /* "AggregateExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2316 "sparql_parser.c"
	break;
      case 125: /* "ExpressionOrStar" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2328 "sparql_parser.c"
	break;
      case 126: /* "CountAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2340 "sparql_parser.c"
	break;
      case 127: /* "SumAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2352 "sparql_parser.c"
	break;
      case 128: /* "AvgAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2364 "sparql_parser.c"
	break;
      case 129: /* "MinAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2376 "sparql_parser.c"
	break;
      case 130: /* "MaxAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2388 "sparql_parser.c"
	break;
      case 131: /* "SeparatorOpt" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2400 "sparql_parser.c"
	break;
      case 133: /* "GroupConcatAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2412 "sparql_parser.c"
	break;
      case 134: /* "SampleAggregateExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2424 "sparql_parser.c"
	break;
      case 135: /* "ConstructQuery" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2436 "sparql_parser.c"
	break;
      case 136: /* "DescribeQuery" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2448 "sparql_parser.c"
	break;
      case 137: /* "VarOrIRIrefList" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2460 "sparql_parser.c"
	break;
      case 139: /* "GraphRef" */

/* Line 1000 of yacc.c  */
#line 276 "./sparql_parser.y"
	{
  if((yyvaluep->uri))
    raptor_free_uri((yyvaluep->uri));
};

/* Line 1000 of yacc.c  */
#line 2472 "sparql_parser.c"
	break;
      case 141: /* "GraphTriples" */

/* Line 1000 of yacc.c  */
#line 300 "./sparql_parser.y"
	{
  if((yyvaluep->update))
    rasqal_free_update_operation((yyvaluep->update));
};

/* Line 1000 of yacc.c  */
#line 2484 "sparql_parser.c"
	break;
      case 142: /* "GraphTemplate" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2496 "sparql_parser.c"
	break;
      case 143: /* "ModifyTemplate" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2508 "sparql_parser.c"
	break;
      case 144: /* "ModifyTemplateList" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2520 "sparql_parser.c"
	break;
      case 150: /* "IriRefList" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2532 "sparql_parser.c"
	break;
      case 156: /* "SourceSelector" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 2544 "sparql_parser.c"
	break;
      case 160: /* "GroupConditionList" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2556 "sparql_parser.c"
	break;
      case 161: /* "GroupCondition" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2568 "sparql_parser.c"
	break;
      case 163: /* "HavingCondition" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2580 "sparql_parser.c"
	break;
      case 164: /* "HavingConditionList" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2592 "sparql_parser.c"
	break;
      case 168: /* "OrderConditionList" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2604 "sparql_parser.c"
	break;
      case 169: /* "OrderCondition" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2616 "sparql_parser.c"
	break;
      case 172: /* "GroupGraphPattern" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2628 "sparql_parser.c"
	break;
      case 173: /* "TriplesBlockOpt" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2640 "sparql_parser.c"
	break;
      case 174: /* "GraphPatternListOpt" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2652 "sparql_parser.c"
	break;
      case 175: /* "GraphPatternList" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2664 "sparql_parser.c"
	break;
      case 176: /* "GraphPatternListFilter" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2676 "sparql_parser.c"
	break;
      case 178: /* "TriplesBlock" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2688 "sparql_parser.c"
	break;
      case 179: /* "GraphPatternNotTriples" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2700 "sparql_parser.c"
	break;
      case 180: /* "OptionalGraphPattern" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2712 "sparql_parser.c"
	break;
      case 181: /* "GraphGraphPattern" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2724 "sparql_parser.c"
	break;
      case 182: /* "GroupOrUnionGraphPattern" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2736 "sparql_parser.c"
	break;
      case 183: /* "GroupOrUnionGraphPatternList" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2748 "sparql_parser.c"
	break;
      case 184: /* "LetGraphPattern" */

/* Line 1000 of yacc.c  */
#line 317 "./sparql_parser.y"
	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */
#line 2760 "sparql_parser.c"
	break;
      case 185: /* "Filter" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2772 "sparql_parser.c"
	break;
      case 186: /* "Constraint" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2784 "sparql_parser.c"
	break;
      case 187: /* "ParamsOpt" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2796 "sparql_parser.c"
	break;
      case 188: /* "FunctionCall" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2808 "sparql_parser.c"
	break;
      case 189: /* "CoalesceExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 2820 "sparql_parser.c"
	break;
      case 190: /* "ArgList" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2832 "sparql_parser.c"
	break;
      case 191: /* "ArgListNoBraces" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2844 "sparql_parser.c"
	break;
      case 192: /* "ConstructTemplate" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2856 "sparql_parser.c"
	break;
      case 193: /* "ConstructTriplesOpt" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2868 "sparql_parser.c"
	break;
      case 194: /* "ConstructTriples" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 2880 "sparql_parser.c"
	break;
      case 195: /* "TriplesSameSubject" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2892 "sparql_parser.c"
	break;
      case 196: /* "PropertyListNotEmpty" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2904 "sparql_parser.c"
	break;
      case 197: /* "PropertyListTailOpt" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2916 "sparql_parser.c"
	break;
      case 198: /* "PropertyList" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2928 "sparql_parser.c"
	break;
      case 199: /* "ObjectList" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2940 "sparql_parser.c"
	break;
      case 200: /* "ObjectTail" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2952 "sparql_parser.c"
	break;
      case 201: /* "Object" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2964 "sparql_parser.c"
	break;
      case 202: /* "Verb" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2976 "sparql_parser.c"
	break;
      case 203: /* "TriplesNode" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 2988 "sparql_parser.c"
	break;
      case 204: /* "BlankNodePropertyList" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3000 "sparql_parser.c"
	break;
      case 205: /* "Collection" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3012 "sparql_parser.c"
	break;
      case 206: /* "GraphNodeListNotEmpty" */

/* Line 1000 of yacc.c  */
#line 288 "./sparql_parser.y"
	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */
#line 3024 "sparql_parser.c"
	break;
      case 207: /* "GraphNode" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3036 "sparql_parser.c"
	break;
      case 208: /* "VarOrTerm" */

/* Line 1000 of yacc.c  */
#line 306 "./sparql_parser.y"
	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */
#line 3048 "sparql_parser.c"
	break;
      case 209: /* "VarOrIRIref" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3060 "sparql_parser.c"
	break;
      case 210: /* "Var" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3072 "sparql_parser.c"
	break;
      case 211: /* "VarName" */

/* Line 1000 of yacc.c  */
#line 356 "./sparql_parser.y"
	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */
#line 3084 "sparql_parser.c"
	break;
      case 213: /* "GraphTerm" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3096 "sparql_parser.c"
	break;
      case 214: /* "Expression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3108 "sparql_parser.c"
	break;
      case 215: /* "ConditionalOrExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3120 "sparql_parser.c"
	break;
      case 216: /* "ConditionalAndExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3132 "sparql_parser.c"
	break;
      case 217: /* "RelationalExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3144 "sparql_parser.c"
	break;
      case 218: /* "AdditiveExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3156 "sparql_parser.c"
	break;
      case 219: /* "MultiplicativeExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3168 "sparql_parser.c"
	break;
      case 220: /* "UnaryExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3180 "sparql_parser.c"
	break;
      case 221: /* "PrimaryExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3192 "sparql_parser.c"
	break;
      case 222: /* "BrackettedExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3204 "sparql_parser.c"
	break;
      case 223: /* "BuiltInCall" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3216 "sparql_parser.c"
	break;
      case 224: /* "RegexExpression" */

/* Line 1000 of yacc.c  */
#line 329 "./sparql_parser.y"
	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */
#line 3228 "sparql_parser.c"
	break;
      case 225: /* "IRIrefBrace" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3240 "sparql_parser.c"
	break;
      case 226: /* "NumericLiteral" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3252 "sparql_parser.c"
	break;
      case 227: /* "NumericLiteralUnsigned" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3264 "sparql_parser.c"
	break;
      case 228: /* "NumericLiteralPositive" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3276 "sparql_parser.c"
	break;
      case 229: /* "NumericLiteralNegative" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3288 "sparql_parser.c"
	break;
      case 230: /* "IRIref" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3300 "sparql_parser.c"
	break;
      case 231: /* "BlankNode" */

/* Line 1000 of yacc.c  */
#line 345 "./sparql_parser.y"
	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */
#line 3312 "sparql_parser.c"
	break;

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 372 "./sparql_parser.y"
    {
}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 378 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(sparql->extended)
    ((rasqal_query*)rq)->explain=1;
  else
    sparql_syntax_error((rasqal_query*)rq, 
                        "EXPLAIN cannot be used with SPARQL 1.0");
}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 389 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 397 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->selects = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_SELECT;
}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 402 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->constructs = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_CONSTRUCT;
}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 407 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->describes = (yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_DESCRIBE;
}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 412 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_ASK;
}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 425 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_DELETE;
}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 429 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_INSERT;
}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 433 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 437 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 441 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 445 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 449 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->verb = RASQAL_QUERY_VERB_UPDATE;
}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 457 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 465 "./sparql_parser.y"
    {
  rasqal_query_set_base_uri((rasqal_query*)rq, (yyvsp[(2) - (2)].uri));
}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 469 "./sparql_parser.y"
    {
  /* nothing to do */
}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 477 "./sparql_parser.y"
    {
  raptor_sequence *seq = ((rasqal_query*)rq)->prefixes;
  unsigned const char* prefix_string = (yyvsp[(3) - (4)].name);
  size_t l = 0;

  if(prefix_string)
    l=strlen((const char*)prefix_string);
  
  if(raptor_namespaces_find_namespace(((rasqal_query*)rq)->namespaces,
                                      prefix_string, l)) {
    /* A prefix may be defined only once */
    sparql_syntax_warning(((rasqal_query*)rq), 
                          "PREFIX %s can be defined only once.",
                          prefix_string ? (const char*)prefix_string : ":");
    RASQAL_FREE(cstring, prefix_string);
    raptor_free_uri((yyvsp[(4) - (4)].uri));
  } else {
    rasqal_prefix *p;
    p = rasqal_new_prefix(((rasqal_query*)rq)->world, prefix_string, (yyvsp[(4) - (4)].uri));
    if(!p)
      YYERROR_MSG("PrefixDeclOpt: failed to create new prefix");
    if(raptor_sequence_push(seq, p))
      YYERROR_MSG("PrefixDeclOpt: cannot push prefix to seq");
    if(rasqal_query_declare_prefix(((rasqal_query*)rq), p)) {
      YYERROR_MSG("PrefixDeclOpt: cannot declare prefix");
    }
  }
}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 506 "./sparql_parser.y"
    {
  /* nothing to do, rq->prefixes already initialised */
}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 515 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(3) - (6)].seq);
  ((rasqal_query*)rq)->distinct = 1;
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(5) - (6)].graph_pattern);
}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 522 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(3) - (6)].seq);
  ((rasqal_query*)rq)->distinct = 2;
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(5) - (6)].graph_pattern);
}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 529 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (5)].seq);
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);
}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 540 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 544 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
  ((rasqal_query*)rq)->wildcard = 1;
}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 555 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 1: sequence push failed");
  }
}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 564 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 2: sequence push failed");
  }
}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 573 "./sparql_parser.y"
    {
  /* The variables are freed from the raptor_query field variables */
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence(NULL,
                           (raptor_data_print_handler)rasqal_variable_print);
#else
  (yyval.seq) = raptor_new_sequence(NULL,
                           (raptor_sequence_print_handler*)rasqal_variable_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("SelectExpressionListTail 3: failed to create sequence");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("SelectExpressionListTail 3: sequence push failed");
  }
}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 597 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(1) - (1)].variable);
}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 601 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.variable) = NULL;
  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "SELECT ( expression ) AS Variable cannot be used with SPARQL 1.0");
  else {
    if(rasqal_expression_mentions_variable((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].variable))) {
      sparql_query_error_full((rasqal_query*)rq, 
                              "Expression in SELECT ( expression ) AS %s contains the variable name '%s'",
                              (yyvsp[(4) - (5)].variable)->name, (yyvsp[(4) - (5)].variable)->name);
    } else {
      (yyval.variable) = (yyvsp[(4) - (5)].variable);
      (yyval.variable)->expression = (yyvsp[(2) - (5)].expr);
    }

  }
}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 641 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 645 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 649 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 653 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 657 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 661 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 665 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 672 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "functions with DISTINCT cannot be used with SPARQL 1.0");
  (yyval.uinteger) = RASQAL_EXPR_FLAG_DISTINCT;
}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 682 "./sparql_parser.y"
    {
  (yyval.uinteger) = 0;
}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 689 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 693 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_0op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_VARSTAR);
}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 701 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq,
                        "COUNT() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_COUNT, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("CountAggregateExpression: cannot create expr");
  }
}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 721 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SUM() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_SUM, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("SumAggregateExpression: cannot create expr");
  }
}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 741 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq,
                        "AVG() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_AVG, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("AvgAggregateExpression: cannot create expr");
  }
}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 761 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MIN() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_MIN, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("MinAggregateExpression: cannot create expr");
  }
}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 781 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq,
                        "MAX() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_MAX, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("MaxAggregateExpression: cannot create expr");
  }
}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 801 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(4) - (4)].literal);
}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 805 "./sparql_parser.y"
    {
  (yyval.literal) = NULL;
}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 815 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("ExpressionList 1: sequence push failed");
  }
}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 824 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("ExpressionList 2: failed to create sequence");

  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("ExpressionList 2: sequence push failed");
  }
}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 845 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq,
                        "GROUP_CONCAT() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    int flags = 0;
    
    if((yyvsp[(3) - (6)].uinteger))
      flags |= RASQAL_EXPR_FLAG_DISTINCT;

    (yyval.expr) = rasqal_new_group_concat_expression(((rasqal_query*)rq)->world,
                                            flags /* flags */,
                                            (yyvsp[(4) - (6)].seq) /* args */,
                                            (yyvsp[(5) - (6)].literal) /* separator */);
    if(!(yyval.expr))
      YYERROR_MSG("GroupConcatAggregateExpression: cannot create expr");
  }
}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 872 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq,
                        "SAMPLE() cannot be used with SPARQL 1.0");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_aggregate_function_expression(((rasqal_query*)rq)->world,
                                                  RASQAL_EXPR_SAMPLE, (yyvsp[(4) - (5)].expr),
                                                  NULL /* params */, (yyvsp[(3) - (5)].uinteger));
    if(!(yyval.expr))
      YYERROR_MSG("SampleAggregateExpression: cannot create expr");
  }
}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 894 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (5)].seq);
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);
}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 904 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (5)].seq);
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);
}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 910 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(4) - (5)].graph_pattern);
}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 919 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 1: sequence push failed");
  }
}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 928 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 2: sequence push failed");
  }
}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 937 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_literal,
                           (raptor_data_print_handler)rasqal_literal_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_literal,
                           (raptor_sequence_print_handler*)rasqal_literal_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("VarOrIRIrefList 3: cannot create seq");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("VarOrIRIrefList 3: sequence push failed");
  }
}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 959 "./sparql_parser.y"
    {
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 967 "./sparql_parser.y"
    {
  (yyval.uri) = (yyvsp[(1) - (1)].uri);
}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 971 "./sparql_parser.y"
    {
  (yyval.uri) = NULL;
}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 979 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE cannot be used with SPARQL 1.0");

  /* LAQRS: experimental syntax */
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "DELETE FROM <uri> ... WHERE ... is deprecated LAQRS syntax.");
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 993 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE cannot be used with SPARQL 1.0");

  /* SPARQL 1.1 (Draft) update:
   * deleting via template + query - not inline atomic triples 
   */

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       NULL /* insert templates */,
                                       (yyvsp[(3) - (5)].seq) /* delete templates */,
                                       (yyvsp[(5) - (5)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("DeleteQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DeleteQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 1022 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "DELETE DATA cannot be used with SPARQL 1.0");

  /* SPARQL 1.1 (Draft) update:
   * deleting inline triples - not inserting from graph URIs 
   */
  (yyvsp[(4) - (5)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(4) - (5)].update)->delete_templates = (yyvsp[(4) - (5)].update)->insert_templates; (yyvsp[(4) - (5)].update)->insert_templates = NULL;
  (yyvsp[(4) - (5)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;
  
  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(4) - (5)].update));
}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 1044 "./sparql_parser.y"
    {
  (yyval.update) = NULL;
 
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.update) = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UNKNOWN,
                                     NULL /* graph_uri */,
                                     NULL /* document_uri */,
                                     (yyvsp[(1) - (1)].formula)->triples /* insert templates */, 
                                     NULL /* delete templates */,
                                     NULL /* where */,
                                     0 /* flags */);
    (yyvsp[(1) - (1)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 1060 "./sparql_parser.y"
    {
  (yyval.update) = NULL;

  if((yyvsp[(4) - (5)].formula)) {
    (yyval.update) = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UNKNOWN,
                                     (yyvsp[(2) - (5)].uri) /* graph uri */,
                                     NULL /* document uri */,
                                     (yyvsp[(4) - (5)].formula)->triples /* insert templates */,
                                     NULL /* delete templates */,
                                     NULL /* where */,
                                     0 /* flags */);
    (yyvsp[(4) - (5)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(4) - (5)].formula));
  }
}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 1080 "./sparql_parser.y"
    {
  if((yyvsp[(4) - (5)].seq)) {
    (yyval.graph_pattern) = rasqal_new_basic_graph_pattern_from_triples((rasqal_query*)rq, (yyvsp[(4) - (5)].seq));
    if(!(yyval.graph_pattern))
      YYERROR_MSG("GraphGraphPattern: cannot create graph pattern");
    else
      rasqal_graph_pattern_set_origin((yyval.graph_pattern), (yyvsp[(2) - (5)].literal));
  }
}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 1095 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (1)].seq))
    (yyval.graph_pattern) = rasqal_new_basic_graph_pattern_from_triples((rasqal_query*)rq, (yyvsp[(1) - (1)].seq));
  else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 1102 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 1110 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);

  if((yyvsp[(2) - (2)].graph_pattern)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].graph_pattern))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ModifyTemplateList 1: sequence push failed");
    }
  }

}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 1123 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                           (raptor_data_print_handler)rasqal_graph_pattern_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern,
                           (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
#endif
  if(!(yyval.seq))
    YYERROR_MSG("ModifyTemplateList 2: cannot create sequence");
  if((yyval.seq)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].graph_pattern))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ModifyTemplateList 2: sequence push failed");
    }
  }
}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 1147 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql  = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT cannot be used with SPARQL 1.0");

  /* LAQRS: experimental syntax */
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "INSERT FROM <uri> ... WHERE ... is deprecated LAQRS syntax.");
  ((rasqal_query*)rq)->query_graph_pattern = (yyvsp[(3) - (3)].graph_pattern);
}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 1161 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT cannot be used with SPARQL 1.0");

  /* inserting via template + query - not inline atomic triples */

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       NULL /* graph_uri */,
                                       NULL /* document_uri */,
                                       (yyvsp[(3) - (5)].seq) /* insert templates */,
                                       NULL /* delete templates */,
                                       (yyvsp[(5) - (5)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("InsertQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("InsertQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 1188 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT DATA cannot be used with SPARQL 1.0");

  /* inserting inline atomic triples (no variables) - not via template */
  (yyvsp[(4) - (5)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(4) - (5)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;

  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(4) - (5)].update));
}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 1209 "./sparql_parser.y"
    {
  rasqal_update_operation* update;

  /* after this $2, $5, $9 and $12 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       (yyvsp[(2) - (11)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       (yyvsp[(9) - (11)].seq) /* insert templates */,
                                       (yyvsp[(5) - (11)].seq) /* delete templates */,
                                       (yyvsp[(11) - (11)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 1: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 1: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 1230 "./sparql_parser.y"
    {
  rasqal_update_operation* update;

  /* after this $2, $5 and $8 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       (yyvsp[(2) - (7)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL /* insert templates */,
                                       (yyvsp[(5) - (7)].seq) /* delete templates */,
                                       (yyvsp[(7) - (7)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 2: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 2: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 1251 "./sparql_parser.y"
    {
  rasqal_update_operation* update;

  /* after this $2, $5 and $8 are owned by update */
  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_UPDATE,
                                       (yyvsp[(2) - (7)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       (yyvsp[(5) - (7)].seq) /* insert templates */,
                                       NULL /* delete templates */,
                                       (yyvsp[(7) - (7)].graph_pattern) /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("UpdateQuery 3: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("UpdateQuery 3: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 1271 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "INSERT DATA cannot be used with SPARQL 1.0");

  /* inserting inline atomic triples (no variables) - not via template */
  (yyvsp[(6) - (7)].update)->graph_uri = (yyvsp[(2) - (7)].uri); /* graph uri */
  (yyvsp[(6) - (7)].update)->type = RASQAL_UPDATE_TYPE_UPDATE;
  (yyvsp[(6) - (7)].update)->flags |= RASQAL_UPDATE_FLAGS_DATA;

  rasqal_query_add_update_operation((rasqal_query*)rq, (yyvsp[(6) - (7)].update));
}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1291 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "CLEAR GRAPH <uri> cannot be used with SPARQL 1.0");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CLEAR,
                                       (yyvsp[(3) - (3)].uri) /* graph uri or NULL */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("ClearQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("ClearQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1315 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "CLEAR cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CLEAR is replaced by CLEAR GRAPH DEFAULT in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CLEAR,
                                       NULL /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /* where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("ClearQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("ClearQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1347 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE <uri> cannot be used with SPARQL 1.0");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(2) - (2)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1371 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE SILENT <uri> cannot be used with SPARQL 1.0");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1395 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE GRAPH <uri> cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CREATE GRAPH <uri> is replaced by CREATE <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1423 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "CREATE SILENT GRAPH <uri> cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "CREATE SILENT GRAPH <uri> is replaced by CREATE SILENT <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_CREATE,
                                       (yyvsp[(4) - (4)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */);
  if(!update) {
    YYERROR_MSG("CreateQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("CreateQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1455 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP <uri> cannot be used with SPARQL 1.0");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       (yyvsp[(2) - (2)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1479 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP SILENT <uri> cannot be used with SPARQL 1.0");


  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */);
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1504 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP GRAPH <uri> cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "DROP GRAPH <uri> is replaced by DROP <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       (yyvsp[(3) - (3)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       0 /* flags */);
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1532 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  rasqal_update_operation* update;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "DROP SILENT GRAPH <uri> cannot be used with SPARQL 1.0");

  /* Early draft syntax - deprecated */
  sparql_syntax_warning((rasqal_query*)rq,
                        "DROP SILENT GRAPH <uri> is replaced by DROP SILENT <uri> in later SPARQL 1.1 drafts");

  update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_DROP,
                                       (yyvsp[(4) - (4)].uri) /* graph uri */, 
                                       NULL /* document uri */,
                                       NULL, NULL,
                                       NULL /*where */,
                                       RASQAL_UPDATE_FLAGS_SILENT /* flags */);
  if(!update) {
    YYERROR_MSG("DropQuery: rasqal_new_update_operation failed");
  } else {
    if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
      YYERROR_MSG("DropQuery: rasqal_query_add_update_operation failed");
  }
}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1564 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].uri))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 1: sequence push failed");
  }
}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1573 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)raptor_free_uri,
                           (raptor_data_print_handler)raptor_uri_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)raptor_free_uri,
                           (raptor_sequence_print_handler*)raptor_uri_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].uri))
      raptor_free_uri((yyvsp[(1) - (1)].uri));
    YYERROR_MSG("IriRefList 2: cannot create sequence");
  }
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].uri))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
    YYERROR_MSG("IriRefList 2: sequence push failed");
  }
}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1597 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  int i;
  raptor_uri* doc_uri;
  
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "LOAD <document uri> cannot be used with SPARQL 1.0");
  
  for(i = 0; (doc_uri = (raptor_uri*)raptor_sequence_get_at((yyvsp[(2) - (2)].seq), i)); i++) {
    rasqal_update_operation* update;
    update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_LOAD,
                                         NULL /* graph uri */, 
                                         raptor_uri_copy(doc_uri) /* document uri */,
                                         NULL, NULL,
                                         NULL /* where */,
                                         0 /* flags */);
    if(!update) {
      YYERROR_MSG("LoadQuery: rasqal_new_update_operation failed");
    } else {
      if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
        YYERROR_MSG("LoadQuery: rasqal_query_add_update_operation failed");
    }
  }

  raptor_free_sequence((yyvsp[(2) - (2)].seq));
}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1627 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  int i;
  raptor_uri* doc_uri;

  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, 
                        "LOAD <document uri> INTO <graph URI> cannot be used with SPARQL 1.0");

  for(i = 0; (doc_uri = (raptor_uri*)raptor_sequence_get_at((yyvsp[(2) - (4)].seq), i)); i++) {
    rasqal_update_operation* update;
    update = rasqal_new_update_operation(RASQAL_UPDATE_TYPE_LOAD,
                                         (yyvsp[(4) - (4)].uri) ? raptor_uri_copy((yyvsp[(4) - (4)].uri)) : NULL /* graph uri */,
                                         raptor_uri_copy(doc_uri) /* document uri */,
                                         NULL, NULL,
                                         NULL /*where */,
                                         0 /* flags */);
    if(!update) {
      YYERROR_MSG("LoadQuery: rasqal_new_update_operation failed");
    } else {
      if(rasqal_query_add_update_operation(((rasqal_query*)rq), update))
        YYERROR_MSG("LoadQuery: rasqal_query_add_update_operation failed");
    }
  }

  raptor_free_sequence((yyvsp[(2) - (4)].seq));
  if((yyvsp[(4) - (4)].uri))
    raptor_free_uri((yyvsp[(4) - (4)].uri));
}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1672 "./sparql_parser.y"
    {
  if((yyvsp[(1) - (1)].literal)) {
    raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (1)].literal));
    if(rasqal_query_add_data_graph((rasqal_query*)rq, uri, NULL,
                                   RASQAL_DATA_GRAPH_BACKGROUND)) {
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
      YYERROR_MSG("DefaultGraphClause: rasqal_query_add_data_graph failed");
    }
    rasqal_free_literal((yyvsp[(1) - (1)].literal));
  }
}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1688 "./sparql_parser.y"
    {
  if((yyvsp[(2) - (2)].literal)) {
    raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(2) - (2)].literal));
    if(rasqal_query_add_data_graph((rasqal_query*)rq, uri, uri,
                                   RASQAL_DATA_GRAPH_NAMED)) {
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
      YYERROR_MSG("NamedGraphClause: rasqal_query_add_data_graph failed");
    }
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
  }
}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1704 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1712 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(2) - (2)].graph_pattern);
}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1716 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1724 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1728 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = NULL;
}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1741 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GroupConditionList 1: sequence push failed");
    }
}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1751 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("GroupConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GroupConditionList 2: sequence push failed");
    }
}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1776 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1780 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1784 "./sparql_parser.y"
    {
  if(rasqal_expression_mentions_variable((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].variable))) {
    sparql_query_error_full((rasqal_query*)rq, 
                            "Expression in GROUP BY ( expression ) AS %s contains the variable name '%s'",
                            (yyvsp[(4) - (5)].variable)->name, (yyvsp[(4) - (5)].variable)->name);
  } else {
    rasqal_literal* l;

    (yyvsp[(4) - (5)].variable)->expression = (yyvsp[(2) - (5)].expr);

    l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(4) - (5)].variable));
    if(!l)
      YYERROR_MSG("GroupCondition 4: cannot create lit");
    (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
    if(!(yyval.expr))
      YYERROR_MSG("GroupCondition 4: cannot create lit expr");
  }
  
}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1804 "./sparql_parser.y"
    {
  rasqal_literal* l;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("GroupCondition 5: cannot create lit");
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("GroupCondition 5: cannot create lit expr");
}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1818 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "GROUP BY cannot be used with SPARQL 1.0");
  else if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, 
                       "GROUP BY cannot be used with ASK");
  } else
    ((rasqal_query*)rq)->group_conditions_sequence = (yyvsp[(3) - (3)].seq);
}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1837 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1844 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("HavingConditionList 1: sequence push failed");
    }
}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1854 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("HavingConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("HavingConditionList 2: sequence push failed");
    }
}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1879 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "HAVING cannot be used with SPARQL 1.0");
  else if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, 
                       "HAVING cannot be used with ASK");
  } else {
    ((rasqal_query*)rq)->having_conditions_sequence = (yyvsp[(2) - (2)].seq);
  }
}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1903 "./sparql_parser.y"
    { 
}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1910 "./sparql_parser.y"
    {
  if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, "ORDER BY cannot be used with ASK");
  } else {
    ((rasqal_query*)rq)->order_conditions_sequence = (yyvsp[(3) - (3)].seq);
  }
}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1923 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("OrderConditionList 1: sequence push failed");
    }
}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1933 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("OrderConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("OrderConditionList 2: sequence push failed");
    }
}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1958 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1965 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_DESC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 2: cannot create expr");
}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1972 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 3: cannot create expr");
}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1980 "./sparql_parser.y"
    {
  rasqal_literal* l;
  rasqal_expression *e;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("OrderCondition 4: cannot create lit");
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("OrderCondition 4: cannot create lit expr");

  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, e);
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1997 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 5: cannot create expr");
}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 2005 "./sparql_parser.y"
    {
  /* The direction of ordering is ascending by default */
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 6: cannot create expr");
}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 2017 "./sparql_parser.y"
    {
  if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, "LIMIT cannot be used with ASK");
  } else {
    if((yyvsp[(2) - (2)].literal) != NULL) {
      ((rasqal_query*)rq)->limit = (yyvsp[(2) - (2)].literal)->value.integer;
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
    }
  }
  
}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 2033 "./sparql_parser.y"
    {
  if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, "LIMIT cannot be used with ASK");
  } else {
    if((yyvsp[(2) - (2)].literal) != NULL) {
      ((rasqal_query*)rq)->offset = (yyvsp[(2) - (2)].literal)->value.integer;
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
    }
  }
}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 2051 "./sparql_parser.y"
    {
  rasqal_graph_pattern *formula_gp = NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GroupGraphPattern\n  TriplesBlockOpt=");
  if((yyvsp[(2) - (4)].formula))
    rasqal_formula_print((yyvsp[(2) - (4)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphpatternListOpt=");
  if((yyvsp[(3) - (4)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(3) - (4)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  if(!(yyvsp[(2) - (4)].formula) && !(yyvsp[(3) - (4)].graph_pattern)) {
    (yyval.graph_pattern) = rasqal_new_2_group_graph_pattern((rasqal_query*)rq, NULL, NULL);
    if(!(yyval.graph_pattern))
      YYERROR_MSG("GroupGraphPattern: cannot create group gp");
  } else {
    if((yyvsp[(2) - (4)].formula)) {
      formula_gp = rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq,
                                                               (yyvsp[(2) - (4)].formula));
      if(!formula_gp) {
        if((yyvsp[(3) - (4)].graph_pattern))
          rasqal_free_graph_pattern((yyvsp[(3) - (4)].graph_pattern));
        YYERROR_MSG("GroupGraphPattern: cannot create formula_gp");
      }
    }

    if((yyvsp[(3) - (4)].graph_pattern)) {
      (yyval.graph_pattern) = (yyvsp[(3) - (4)].graph_pattern);
      if(formula_gp && raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, formula_gp)) {
        rasqal_free_graph_pattern((yyval.graph_pattern));
        (yyval.graph_pattern) = NULL;
        YYERROR_MSG("GroupGraphPattern: sequence push failed");
      }
    } else
      (yyval.graph_pattern) = formula_gp;
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 2109 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlockOpt 1\n  TriplesBlock=");
  if((yyvsp[(1) - (1)].formula))
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 2122 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 2135 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListOpt\n  GraphPatternListOpt=");
  if((yyvsp[(1) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphPatternList=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) =  ((yyvsp[(1) - (2)].graph_pattern) ? (yyvsp[(1) - (2)].graph_pattern) : (yyvsp[(2) - (2)].graph_pattern));
  if((yyvsp[(1) - (2)].graph_pattern) && (yyvsp[(2) - (2)].graph_pattern)) {
    (yyval.graph_pattern) = (yyvsp[(1) - (2)].graph_pattern);
    if(rasqal_graph_patterns_join((yyval.graph_pattern), (yyvsp[(2) - (2)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      (yyval.graph_pattern) = NULL;
      YYERROR_MSG("GraphPatternListOpt: sequence join failed");
    }
    rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after grouping graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 2172 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 2176 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = NULL;
}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 2189 "./sparql_parser.y"
    {
  rasqal_graph_pattern *formula_gp = NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternList\n  GraphPatternListFilter=");
  if((yyvsp[(1) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].formula)) {
    formula_gp = rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq, 
                                                             (yyvsp[(3) - (3)].formula));
    if(!formula_gp) {
      if((yyvsp[(1) - (3)].graph_pattern))
        rasqal_free_graph_pattern((yyvsp[(1) - (3)].graph_pattern));
      YYERROR_MSG("GraphPatternList: cannot create formula_gp");
    }
  }
  (yyval.graph_pattern) = rasqal_new_2_group_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (3)].graph_pattern), formula_gp);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternList: cannot create sequence");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 2237 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 1\n  GraphPatternNotTriples=");
  if((yyvsp[(1) - (1)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (1)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 2250 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 2\n  Filter=");
  if((yyvsp[(1) - (1)].expr))
    rasqal_expression_print((yyvsp[(1) - (1)].expr), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = rasqal_new_filter_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (1)].expr));
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternListFilter 2: cannot create graph pattern");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 2284 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlock\n  TriplesSameSubject=");
  if((yyvsp[(1) - (3)].formula))
    rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  (yyval.formula) =  ((yyvsp[(1) - (3)].formula) ? (yyvsp[(1) - (3)].formula) : (yyvsp[(3) - (3)].formula));
  if((yyvsp[(1) - (3)].formula) && (yyvsp[(3) - (3)].formula)) {
    /* $1 and $3 are freed as necessary */
    (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (3)].formula), (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(1) - (3)].formula))
      YYERROR_MSG("TriplesBlock: formula join failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 2315 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 2323 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 2327 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 2331 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 2335 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 2343 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PatternElementForms 4\n  graphpattern=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern) = NULL;

  if((yyvsp[(2) - (2)].graph_pattern)) {
    raptor_sequence *seq;

#ifdef HAVE_RAPTOR2_API
    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                              (raptor_data_print_handler)rasqal_graph_pattern_print);
#else
    seq = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern,
                              (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
#endif
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      YYERROR_MSG("OptionalGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(2) - (2)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("OptionalGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_OPTIONAL);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("OptionalGraphPattern: cannot create graph pattern");
      }
    }
  }
}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 2387 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern 2\n  varoruri=");
  rasqal_literal_print((yyvsp[(2) - (3)].literal), DEBUG_FH);
  fprintf(DEBUG_FH, ", graphpattern=");
  if((yyvsp[(3) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(3) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].graph_pattern)) {
    raptor_sequence *seq;

#ifdef HAVE_RAPTOR2_API
    seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                              (raptor_data_print_handler)rasqal_graph_pattern_print);
#else
    seq = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern,
                              (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
#endif
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(3) - (3)].graph_pattern));
      YYERROR_MSG("GraphGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(3) - (3)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("GraphGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_GRAPH);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("GraphGraphPattern: cannot create graph pattern");
        else
          rasqal_graph_pattern_set_origin((yyval.graph_pattern), (yyvsp[(2) - (3)].literal));
      }
    }
  }


#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  rasqal_free_literal((yyvsp[(2) - (3)].literal));
}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 2442 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(3) - (3)].graph_pattern);
  if(raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, (yyvsp[(1) - (3)].graph_pattern))) {
    rasqal_free_graph_pattern((yyval.graph_pattern));
    (yyval.graph_pattern) = NULL;
    YYERROR_MSG("GroupOrUnionGraphPattern: sequence push failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "UnionGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif
}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 2457 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 2464 "./sparql_parser.y"
    {
  (yyval.graph_pattern) = (yyvsp[(1) - (3)].graph_pattern);
  if((yyvsp[(3) - (3)].graph_pattern))
    if(raptor_sequence_push((yyval.graph_pattern)->graph_patterns, (yyvsp[(3) - (3)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      (yyval.graph_pattern) = NULL;
      YYERROR_MSG("GroupOrUnionGraphPatternList 1: sequence push failed");
    }
}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 2474 "./sparql_parser.y"
    {
  raptor_sequence *seq;
#ifdef HAVE_RAPTOR2_API
  seq = raptor_new_sequence((raptor_data_free_handler)rasqal_free_graph_pattern,
                            (raptor_data_print_handler)rasqal_graph_pattern_print);
#else
  seq = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern,
                            (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
#endif
  if(!seq) {
    if((yyvsp[(1) - (1)].graph_pattern))
      rasqal_free_graph_pattern((yyvsp[(1) - (1)].graph_pattern));
    YYERROR_MSG("GroupOrUnionGraphPatternList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].graph_pattern))
    if(raptor_sequence_push(seq, (yyvsp[(1) - (1)].graph_pattern))) {
      raptor_free_sequence(seq);
      YYERROR_MSG("GroupOrUnionGraphPatternList 2: sequence push failed");
    }
  (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                              seq,
                                              RASQAL_GRAPH_PATTERN_OPERATOR_UNION);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GroupOrUnionGraphPatternList 1: cannot create gp");
}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 2504 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if((yyvsp[(3) - (6)].variable) && (yyvsp[(5) - (6)].expr)) {
    if(sparql->extended)
      (yyval.graph_pattern) = rasqal_new_let_graph_pattern((rasqal_query*)rq, (yyvsp[(3) - (6)].variable), (yyvsp[(5) - (6)].expr));
    else {
      sparql_syntax_error((rasqal_query*)rq,
                          "LET cannot be used with SPARQL 1.0");
      rasqal_free_expression((yyvsp[(5) - (6)].expr));
      (yyval.graph_pattern) = NULL;
    }
  } else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 2525 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (2)].expr);
}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 2533 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 2537 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 2541 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 2548 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 2552 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 2560 "./sparql_parser.y"
    {
  raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (6)].literal));
  
  if(!(yyvsp[(4) - (6)].seq)) {
#ifdef HAVE_RAPTOR2_API
    (yyvsp[(4) - (6)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
#else
    (yyvsp[(4) - (6)].seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                             (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
    if(!(yyvsp[(4) - (6)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (6)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

  uri = raptor_uri_copy(uri);

  if(raptor_sequence_size((yyvsp[(4) - (6)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e = (rasqal_expression*)raptor_sequence_pop((yyvsp[(4) - (6)].seq));
    (yyval.expr) = rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    if((yyval.expr))
      (yyval.expr)->flags |= (yyvsp[(3) - (6)].uinteger);
    raptor_free_sequence((yyvsp[(4) - (6)].seq));
  } else {
    unsigned int flags = 0;
    if((yyvsp[(3) - (6)].uinteger))
      flags |= 1;
    
    (yyval.expr) = rasqal_new_function_expression2(((rasqal_query*)rq)->world, 
                                         uri, (yyvsp[(4) - (6)].seq), (yyvsp[(5) - (6)].seq) /* params */,
                                         flags);
    if((yyval.expr))
      (yyval.expr)->flags |= (yyvsp[(3) - (6)].uinteger);
  }
  rasqal_free_literal((yyvsp[(1) - (6)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 2604 "./sparql_parser.y"
    {
  raptor_uri* uri = rasqal_literal_as_uri((yyvsp[(1) - (3)].literal));
  
  if(!(yyvsp[(2) - (3)].seq)) {
#ifdef HAVE_RAPTOR2_API
    (yyvsp[(2) - (3)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
#else
    (yyvsp[(2) - (3)].seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                             (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
    if(!(yyvsp[(2) - (3)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (3)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

  uri = raptor_uri_copy(uri);

  if(raptor_sequence_size((yyvsp[(2) - (3)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e = (rasqal_expression*)raptor_sequence_pop((yyvsp[(2) - (3)].seq));
    (yyval.expr) = rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  } else {
    (yyval.expr) = rasqal_new_function_expression2(((rasqal_query*)rq)->world,
                                         uri, (yyvsp[(2) - (3)].seq), NULL /* params */,
                                         0 /* flags */);
  }
  rasqal_free_literal((yyvsp[(1) - (3)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 2643 "./sparql_parser.y"
    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq,
                        "COALESCE cannot be used with SPARQL 1.0");

  if(!(yyvsp[(2) - (2)].seq)) {
#ifdef HAVE_RAPTOR2_API
    (yyvsp[(2) - (2)].seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                             (raptor_data_print_handler)rasqal_expression_print);
#else
    (yyvsp[(2) - (2)].seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                             (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
    if(!(yyvsp[(2) - (2)].seq))
      YYERROR_MSG("FunctionCall: cannot create sequence");
  }

  (yyval.expr) = rasqal_new_coalesce_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].seq));
  if(!(yyval.expr))
    YYERROR_MSG("Coalesce: cannot create expr");
}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 2672 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (3)].seq);
}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 2679 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (3)].seq);
  if((yyvsp[(3) - (3)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ArgListNoBraces 1: sequence push failed");
    }
}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 2689 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_expression,
                           (raptor_data_print_handler)rasqal_expression_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression,
                           (raptor_sequence_print_handler*)rasqal_expression_print);
#endif
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("ArgListNoBraces 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ArgListNoBraces 2: sequence push failed");
    }
}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 2710 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 2718 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(2) - (3)].seq);
}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 2726 "./sparql_parser.y"
    {
  (yyval.seq) = (yyvsp[(1) - (1)].seq);
}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 2730 "./sparql_parser.y"
    {
#ifdef HAVE_RAPTOR2_API
  (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                           (raptor_data_print_handler)rasqal_triple_print);
#else
  (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                           (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
  if(!(yyval.seq)) {
    YYERROR_MSG("ConstructTriplesOpt: cannot create sequence");
  }
}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 2747 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
 
  if((yyvsp[(1) - (3)].formula)) {
    (yyval.seq) = (yyvsp[(1) - (3)].formula)->triples;
    (yyvsp[(1) - (3)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (3)].formula));
  }
  
  if((yyvsp[(3) - (3)].seq)) {
    if(!(yyval.seq)) {
#ifdef HAVE_RAPTOR2_API
      (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                               (raptor_data_print_handler)rasqal_triple_print);
#else
      (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                               (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
      if(!(yyval.seq)) {
        raptor_free_sequence((yyvsp[(3) - (3)].seq));
        YYERROR_MSG("ConstructTriples: cannot create sequence");
      }
    }

    if(raptor_sequence_join((yyval.seq), (yyvsp[(3) - (3)].seq))) {
      raptor_free_sequence((yyvsp[(3) - (3)].seq));
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("ConstructTriples: sequence join failed");
    }
    raptor_free_sequence((yyvsp[(3) - (3)].seq));
  }

 }
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 2782 "./sparql_parser.y"
    {
  (yyval.seq) = NULL;
  
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.seq) = (yyvsp[(1) - (1)].formula)->triples;
    (yyvsp[(1) - (1)].formula)->triples = NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
  
}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 2797 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 1\n  subject=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject = (yyvsp[(1) - (2)].formula)->value;
    int size = raptor_sequence_size(seq);
    
    /* non-empty property list, handle it  */
    for(i = 0; i < size; i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject = rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 1: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 2841 "./sparql_parser.y"
    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 2\n  TriplesNode=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject = (yyvsp[(1) - (2)].formula)->value;
    int size = raptor_sequence_size(seq);
    
    /* non-empty property list, handle it  */
    for(i = 0; i < size; i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject = rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula) = rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 2: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 2889 "./sparql_parser.y"
    {
  int i;
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PropertyList 1\n  Verb=");
  rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  ObjectList=");
  rasqal_formula_print((yyvsp[(2) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  PropertyListTail=");
  if((yyvsp[(3) - (3)].formula) != NULL)
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif
  
  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, " empty ObjectList not processed\n");
#endif
  } else if((yyvsp[(1) - (3)].formula) && (yyvsp[(2) - (3)].formula)) {
    raptor_sequence *seq = (yyvsp[(2) - (3)].formula)->triples;
    rasqal_literal *predicate = (yyvsp[(1) - (3)].formula)->value;
    rasqal_formula *formula;
    rasqal_triple *t2;
    int size;
    
    formula = rasqal_new_formula(((rasqal_query*)rq)->world);
    if(!formula) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create formula");
    }
#ifdef HAVE_RAPTOR2_API
    formula->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                           (raptor_data_print_handler)rasqal_triple_print);
#else
    formula->triples = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                                           (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
    if(!formula->triples) {
      rasqal_free_formula(formula);
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create sequence");
    }

    /* non-empty property list, handle it  */
    size = raptor_sequence_size(seq);
    for(i = 0; i < size; i++) {
      t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(!t2->predicate)
        t2->predicate = (rasqal_literal*)rasqal_new_literal_from_literal(predicate);
    }
  
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution ObjectList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    while(raptor_sequence_size(seq)) {
      t2 = (rasqal_triple*)raptor_sequence_unshift(seq);
      if(raptor_sequence_push(formula->triples, t2)) {
        rasqal_free_formula(formula);
        rasqal_free_formula((yyvsp[(1) - (3)].formula));
        rasqal_free_formula((yyvsp[(2) - (3)].formula));
        if((yyvsp[(3) - (3)].formula))
          rasqal_free_formula((yyvsp[(3) - (3)].formula));
        YYERROR_MSG("PropertyList 1: sequence push failed");
      }
    }

    (yyvsp[(3) - (3)].formula) = rasqal_formula_join(formula, (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(3) - (3)].formula)) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      YYERROR_MSG("PropertyList 1: formula join failed");
    }

#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after appending ObjectList=");
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif

    rasqal_free_formula((yyvsp[(2) - (3)].formula));
  }

  if((yyvsp[(1) - (3)].formula))
    rasqal_free_formula((yyvsp[(1) - (3)].formula));

  (yyval.formula) = (yyvsp[(3) - (3)].formula);
}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 2992 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(2) - (2)].formula);
}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 2996 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 3004 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 3008 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 3016 "./sparql_parser.y"
    {
  rasqal_formula *formula;
  rasqal_triple *triple;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "ObjectList 1\n");
  fprintf(DEBUG_FH, "  Object=\n");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  ObjectTail=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty ObjectTail\n");
#endif

  formula = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!formula) {
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create formula");
  }
  
#ifdef HAVE_RAPTOR2_API
  formula->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                         (raptor_data_print_handler)rasqal_triple_print);
#else
  formula->triples = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                                         (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
  if(!formula->triples) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create sequence");
  }

  triple = rasqal_new_triple(NULL, NULL, (yyvsp[(1) - (2)].formula)->value);
  (yyvsp[(1) - (2)].formula)->value = NULL; /* value now owned by triple */
  if(!triple) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create triple");
  }

  if(raptor_sequence_push(formula->triples, triple)) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: sequence push failed");
  }

  (yyval.formula) = rasqal_formula_join(formula, (yyvsp[(1) - (2)].formula));
  if(!(yyval.formula)) {
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: formula join $1 failed");
  }

  (yyval.formula) = rasqal_formula_join((yyval.formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("ObjectList: formula join $2 failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  objectList is now ");
  if((yyval.formula))
    raptor_sequence_print((yyval.formula)->triples, DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 3099 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(2) - (2)].formula);
}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 3103 "./sparql_parser.y"
    {
  (yyval.formula) = NULL;
}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 3111 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 3119 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("Verb 1: cannot create formula");
  }
  (yyval.formula)->value = (yyvsp[(1) - (1)].literal);
}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 3129 "./sparql_parser.y"
    {
  raptor_uri *uri;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "verb Verb=rdf:type (a)\n");
#endif

#ifdef HAVE_RAPTOR2_API
  uri = raptor_new_uri_for_rdf_concept(((rasqal_query*)rq)->world->raptor_world_ptr,
                                       (const unsigned char*)"type");
#else
  uri = raptor_new_uri_for_rdf_concept("type");
#endif
  if(!uri)
    YYERROR_MSG("Verb 2: uri for rdf concept type failed");
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    raptor_free_uri(uri);
    YYERROR_MSG("Verb 2: cannot create formula");
  }
  (yyval.formula)->value = rasqal_new_uri_literal(((rasqal_query*)rq)->world, uri);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("Verb 2: cannot create uri literal");
  }
}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 3161 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 3165 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 3173 "./sparql_parser.y"
    {
  int i;
  const unsigned char *id;

  if((yyvsp[(2) - (3)].formula) == NULL) {
    (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
    if(!(yyval.formula))
      YYERROR_MSG("BlankNodePropertyList: cannot create formula");
  } else {
    (yyval.formula) = (yyvsp[(2) - (3)].formula);
    if((yyval.formula)->value) {
      rasqal_free_literal((yyval.formula)->value);
      (yyval.formula)->value = NULL;
    }
  }
  
  id = rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("BlankNodeProperyList: cannot create bnodeid");
  }

  (yyval.formula)->value = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                        RASQAL_LITERAL_BLANK, id);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("BlankNodePropertyList: cannot create literal");
  }

  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  } else {
    raptor_sequence *seq = (yyvsp[(2) - (3)].formula)->triples;

    /* non-empty property list, handle it  */
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    for(i = 0; i<raptor_sequence_size(seq); i++) {
      rasqal_triple* t2 = (rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      
      t2->subject = (rasqal_literal*)rasqal_new_literal_from_literal((yyval.formula)->value);
    }

#if RASQAL_DEBUG > 1
    fprintf(DEBUG_FH, "  after substitution formula=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }
}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 3240 "./sparql_parser.y"
    {
  int i;
  rasqal_query* rdf_query = (rasqal_query*)rq;
  rasqal_literal* first_identifier = NULL;
  rasqal_literal* rest_identifier = NULL;
  rasqal_literal* object = NULL;
  rasqal_literal* blank = NULL;

#if RASQAL_DEBUG > 1
  char const *errmsg;
  #define YYERR_MSG_GOTO(label,msg) do { errmsg = msg; goto label; } while(0)
#else
  #define YYERR_MSG_GOTO(label,ignore) goto label
#endif

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "Collection\n  GraphNodeListNotEmpty=");
  raptor_sequence_print((yyvsp[(2) - (3)].seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif

  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula))
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create formula");

#ifdef HAVE_RAPTOR2_API
  (yyval.formula)->triples = raptor_new_sequence((raptor_data_free_handler)rasqal_free_triple,
                                    (raptor_data_print_handler)rasqal_triple_print);
#else
  (yyval.formula)->triples = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple,
                                    (raptor_sequence_print_handler*)rasqal_triple_print);
#endif
  if(!(yyval.formula)->triples)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create sequence");

  first_identifier = rasqal_new_uri_literal(rdf_query->world,
                                            raptor_uri_copy(rdf_query->world->rdf_first_uri));
  if(!first_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot first_identifier");
  
  rest_identifier = rasqal_new_uri_literal(rdf_query->world,
                                           raptor_uri_copy(rdf_query->world->rdf_rest_uri));
  if(!rest_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create rest_identifier");
  
  object = rasqal_new_uri_literal(rdf_query->world,
                                  raptor_uri_copy(rdf_query->world->rdf_nil_uri));
  if(!object)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create nil object");

  for(i = raptor_sequence_size((yyvsp[(2) - (3)].seq))-1; i >= 0; i--) {
    rasqal_formula* f = (rasqal_formula*)raptor_sequence_get_at((yyvsp[(2) - (3)].seq), i);
    rasqal_triple *t2;
    const unsigned char *blank_id = NULL;

    blank_id = rasqal_query_generate_bnodeid(rdf_query, NULL);
    if(!blank_id)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnodeid");

    blank = rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_BLANK, blank_id);
    if(!blank)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnode");

    /* Move existing formula triples */
    if(f->triples)
      if(raptor_sequence_join((yyval.formula)->triples, f->triples))
        YYERR_MSG_GOTO(err_Collection, "Collection: sequence join failed");

    /* add new triples we needed */
    t2 = rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                           rasqal_new_literal_from_literal(first_identifier),
                           rasqal_new_literal_from_literal(f->value));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    t2 = rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                           rasqal_new_literal_from_literal(rest_identifier),
                           rasqal_new_literal_from_literal(object));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple 2");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: sequence push 2 failed");

    rasqal_free_literal(object);
    object=blank;
    blank = NULL;
  }

  /* free sequence of formulas just processed */
  raptor_free_sequence((yyvsp[(2) - (3)].seq));
  
  (yyval.formula)->value=object;
  
#if RASQAL_DEBUG > 1
  fprintf(DEBUG_FH, "  after substitution collection=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif

  rasqal_free_literal(first_identifier);
  rasqal_free_literal(rest_identifier);

  break; /* success */

  err_Collection:
  
  if(blank)
    rasqal_free_literal(blank);
  if(object)
    rasqal_free_literal(object);
  if(rest_identifier)
    rasqal_free_literal(rest_identifier);
  if(first_identifier)
    rasqal_free_literal(first_identifier);
  if((yyvsp[(2) - (3)].seq))
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  if((yyval.formula)) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 3372 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  char const *errmsg;

  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 1\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
  if((yyvsp[(1) - (2)].seq)) {
    fprintf(DEBUG_FH, "  GraphNodeListNotEmpty=");
    raptor_sequence_print((yyvsp[(1) - (2)].seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty GraphNodeListNotEmpty\n");
#endif

  (yyval.seq) = (yyvsp[(1) - (2)].seq);
  if(!(yyval.seq)) {
#ifdef HAVE_RAPTOR2_API
    (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_formula,
                             (raptor_data_print_handler)rasqal_formula_print);
#else
    (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_formula,
                             (raptor_sequence_print_handler*)rasqal_formula_print);
#endif
    if(!(yyval.seq))
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty,
                     "GraphNodeListNotEmpty: cannot create formula");
  }
  
  if((yyvsp[(2) - (2)].formula)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].formula))) {
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty,
                     "GraphNodeListNotEmpty 1: sequence push failed");
    }
    (yyvsp[(2) - (2)].formula) = NULL;
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  itemList is now ");
    raptor_sequence_print((yyval.seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }

  break; /* success */

  err_GraphNodeListNotEmpty:
  if((yyvsp[(2) - (2)].formula))
    rasqal_free_formula((yyvsp[(2) - (2)].formula));
  if((yyval.seq)) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq) = NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 3430 "./sparql_parser.y"
    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 2\n");
  if((yyvsp[(1) - (1)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
#endif

  if(!(yyvsp[(1) - (1)].formula))
    (yyval.seq) = NULL;
  else {
#ifdef HAVE_RAPTOR2_API
    (yyval.seq) = raptor_new_sequence((raptor_data_free_handler)rasqal_free_formula,
                             (raptor_data_print_handler)rasqal_formula_print);
#else
    (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_formula,
                             (raptor_sequence_print_handler*)rasqal_formula_print);
#endif
    if(!(yyval.seq)) {
      rasqal_free_formula((yyvsp[(1) - (1)].formula));
      YYERROR_MSG("GraphNodeListNotEmpty 2: cannot create sequence");
    }
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].formula))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq) = NULL;
      YYERROR_MSG("GraphNodeListNotEmpty 2: sequence push failed");
    }
  }
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  GraphNodeListNotEmpty is now ");
  raptor_sequence_print((yyval.seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 3472 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 3476 "./sparql_parser.y"
    {
  (yyval.formula) = (yyvsp[(1) - (1)].formula);
}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 3484 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula))
    YYERROR_MSG("VarOrTerm 1: cannot create formula");
  (yyval.formula)->value = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula) = NULL;
    YYERROR_MSG("VarOrTerm 1: cannot create literal");
  }
}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 3496 "./sparql_parser.y"
    {
  (yyval.formula) = rasqal_new_formula(((rasqal_query*)rq)->world);
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("VarOrTerm 2: cannot create formula");
  }
  (yyval.formula)->value = (yyvsp[(1) - (1)].literal);
}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 3509 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.literal))
    YYERROR_MSG("VarOrIRIref: cannot create literal");
}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 3515 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 3523 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 3527 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 3534 "./sparql_parser.y"
    {
  (yyval.variable) = rasqal_new_variable((rasqal_query*)rq, (yyvsp[(1) - (1)].name), NULL);
  if(!(yyval.variable))
    YYERROR_MSG("VarName: cannot create var");
}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 3544 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 3548 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(2) - (2)].variable);
}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 3552 "./sparql_parser.y"
    {
  (yyval.variable) = (yyvsp[(1) - (1)].variable);
  sparql_syntax_warning(((rasqal_query*)rq), 
                        "... AS varname is deprecated LAQRS syntax, use ... AS ?varname");
}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 3562 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 3566 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 3570 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 3574 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 3578 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 3582 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, 
                              raptor_uri_copy(((rasqal_query*)rq)->world->rdf_nil_uri));
  if(!(yyval.literal))
    YYERROR_MSG("GraphTerm: cannot create literal");
}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 3592 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 3600 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_OR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalOrExpression: cannot create expr");
}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 3607 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 3615 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_AND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalAndExpression: cannot create expr");
;
}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 3623 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 3632 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_EQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 1: cannot create expr");
}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 3639 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_NEQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 2: cannot create expr");
}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 3646 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 3: cannot create expr");
}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 3653 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_GT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 4: cannot create expr");
}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 3660 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 5: cannot create expr");
}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 3667 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_GE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 6: cannot create expr");
}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 3674 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_set_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_IN, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].seq));
}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 3679 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_set_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_NOT_IN, (yyvsp[(1) - (4)].expr), (yyvsp[(4) - (4)].seq));
}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 3684 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 3693 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 1: cannot create expr");
}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 3700 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_MINUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 2: cannot create expr");
}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 3707 "./sparql_parser.y"
    {
  rasqal_expression *e;
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 3: cannot create expr");
  }
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 4: cannot create expr");
}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 3720 "./sparql_parser.y"
    {
  rasqal_expression *e;
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 5: cannot create expr");
  }
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 6: cannot create expr");
}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 3733 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 3740 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STAR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 1: cannot create expr");
}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 3747 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SLASH, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 2: cannot create expr");
}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 3754 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 3762 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_BANG, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 1: cannot create expr");
}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 3769 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (2)].expr);
}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 3773 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_UMINUS, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 3: cannot create expr");
}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 3780 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 3794 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 3798 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 3802 "./sparql_parser.y"
    {
  /* Grammar has IRIrefOrFunction here which is "IRIref ArgList?"
   * and essentially shorthand for FunctionCall | IRIref.  The Rasqal
   * SPARQL lexer distinguishes these for us with IRIrefBrace.
   * IRIref is covered below by GraphTerm.
   */
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 3811 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].literal));
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 4: cannot create expr");
}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 3817 "./sparql_parser.y"
    {
  rasqal_literal *l;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("PrimaryExpression 5: cannot create literal");
  (yyval.expr) = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 5: cannot create expr");
}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 3827 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 3835 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(2) - (3)].expr);
}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 3843 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 1: cannot create expr");
}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 3850 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LANG, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 2: cannot create expr");
}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 3857 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_LANGMATCHES, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 3: cannot create expr");
}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 3864 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_DATATYPE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 4: cannot create expr");
}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 3871 "./sparql_parser.y"
    {
  rasqal_literal *l;
  rasqal_expression *e;
  l = rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(3) - (4)].variable));
  if(!l)
    YYERROR_MSG("BuiltInCall 5: cannot create literal");
  e = rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("BuiltInCall 6: cannot create literal expr");
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_BOUND, e);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7: cannot create expr");
}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 3886 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_IRI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7a: cannot create expr");
}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 3893 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_IRI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7b: cannot create expr");
}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 3900 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_BNODE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7c: cannot create expr");
}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 3907 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world, 
                                 RASQAL_EXPR_BNODE, NULL);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7d: cannot create expr");
}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 3914 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 3918 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_IF, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7e: cannot create expr");
}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 3925 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRLANG, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7f: cannot create expr");
}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 3932 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_STRDT, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7g: cannot create expr");
}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 3939 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_2op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_SAMETERM, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 8: cannot create expr");
}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 3946 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISURI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 9: cannot create expr");
}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 3953 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISBLANK, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 10: cannot create expr");
}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 3960 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_ISLITERAL, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 11: cannot create expr");
}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 3967 "./sparql_parser.y"
    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 3975 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REGEX, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr), NULL);
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 1: cannot create expr");
}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 3982 "./sparql_parser.y"
    {
  (yyval.expr) = rasqal_new_3op_expression(((rasqal_query*)rq)->world,
                                 RASQAL_EXPR_REGEX, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 2: cannot create expr");
}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 3996 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 1: cannot create literal");
}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 4002 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal) = NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 4022 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 4026 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 4030 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 4037 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 4041 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 4045 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 4053 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 4057 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 4061 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 4069 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 4073 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 4077 "./sparql_parser.y"
    {
  (yyval.literal) = (yyvsp[(1) - (1)].literal);
}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 4089 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 1: cannot create literal");
}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 4095 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal) = NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 4115 "./sparql_parser.y"
    {
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_BLANK, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 1: cannot create literal");
}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 4121 "./sparql_parser.y"
    {
  const unsigned char *id;
  id = rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id)
    YYERROR_MSG("BlankNode 2: cannot create bnodeid");
  (yyval.literal) = rasqal_new_simple_literal(((rasqal_query*)rq)->world,
                                 RASQAL_LITERAL_BLANK, id);
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 2: cannot create literal");
}
    break;



/* Line 1455 of yacc.c  */
#line 8173 "sparql_parser.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 4140 "./sparql_parser.y"



/* Support functions */


/* This is declared in sparql_lexer.h but never used, so we always get
 * a warning unless this dummy code is here.  Used once below in an error case.
 */
static int yy_init_globals (yyscan_t yyscanner ) { return 0; }


/**
 * rasqal_sparql_query_language_init - Initialise the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static int
rasqal_sparql_query_language_init(rasqal_query* rdf_query, const char *name)
{
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rdf_query->context;

  rdf_query->compare_flags = RASQAL_COMPARE_XQUERY;

  rqe->extended = (strcmp(name, "laqrs") == 0);
  return 0;
}


/**
 * rasqal_sparql_query_language_terminate - Free the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static void
rasqal_sparql_query_language_terminate(rasqal_query* rdf_query)
{
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)rdf_query->context;

  if(sparql && sparql->scanner_set) {
    sparql_lexer_lex_destroy(sparql->scanner);
    sparql->scanner_set = 0;
  }

}


static int
rasqal_sparql_query_language_prepare(rasqal_query* rdf_query)
{
  /* rasqal_sparql_query_language* sparql = (rasqal_sparql_query_language*)rdf_query->context; */
  int rc;
  
  if(!rdf_query->query_string)
    return 1;
  
  rc=sparql_parse(rdf_query);
  if(rc)
    return rc;

  /* FIXME - should check remaining query parts  */
  if(rasqal_sequence_has_qname(rdf_query->triples) ||
     rasqal_sequence_has_qname(rdf_query->constructs) ||
     rasqal_query_constraints_has_qname(rdf_query)) {
    sparql_query_error(rdf_query, "SPARQL query has unexpanded QNames");
    return 1;
  }

  /* SPARQL: Turn [] into anonymous variables */
  if(rasqal_query_build_anonymous_variables(rdf_query))
    return 1;
  
  /* SPARQL: Expand 'SELECT *' */
  if(rasqal_query_expand_wildcards(rdf_query))
    return 1;
  
  return 0;
}


static int
sparql_parse(rasqal_query* rq)
{
  rasqal_sparql_query_language* rqe;
  raptor_locator *locator=&rq->locator;
  void *buffer;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(!rq->query_string)
    return yy_init_globals(NULL); /* 0 but a way to use yy_init_globals */

  locator->line = 1;
  locator->column = -1; /* No column info */
  locator->byte = -1; /* No bytes info */

#if RASQAL_DEBUG > 2
  sparql_parser_debug = 1;
#endif

  rqe->lineno = 1;

  if(sparql_lexer_lex_init(&rqe->scanner))
    return 1;
  rqe->scanner_set = 1;

  sparql_lexer_set_extra(((rasqal_query*)rq), rqe->scanner);

  buffer = sparql_lexer__scan_buffer((char*)rq->query_string,
                                     rq->query_string_length, rqe->scanner);

  rqe->error_count = 0;

  sparql_parser_parse(rq);

  sparql_lexer_lex_destroy(rqe->scanner);
  rqe->scanner_set = 0;

  /* Parsing failed */
  if(rq->failed)
    return 1;
  
  return 0;
}


static void
sparql_query_error(rasqal_query *rq, const char *msg)
{
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column = sparql_lexer_get_column(yyscanner);*/
#endif

  rq->failed = 1;
  rasqal_log_error_simple(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                          &rq->locator, "%s", msg);
}


static void
sparql_query_error_full(rasqal_query *rq, const char *message, ...)
{
  va_list arguments;
  rasqal_sparql_query_language* rqe;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column = sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);

  rq->failed = 1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                           &rq->locator, message, arguments);

  va_end(arguments);
}


int
sparql_syntax_error(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe;
  va_list arguments;

  rqe = (rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return 0;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rp->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rq->failed = 1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR,
                           &rq->locator, message, arguments);
  va_end(arguments);

  return 0;
}


int
sparql_syntax_warning(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe;
  va_list arguments;

  rqe = (rasqal_sparql_query_language*)rq->context;

  rq->locator.line = rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rasqal_log_error_varargs(((rasqal_query*)rq)->world,
                           RAPTOR_LOG_LEVEL_WARN,
                           &rq->locator, message,
                           arguments);
  va_end(arguments);

  return (0);
}


static int
rasqal_sparql_query_language_iostream_write_escaped_counted_string(rasqal_query* query,
                                                                   raptor_iostream* iostr,
                                                                   const unsigned char* string,
                                                                   size_t len)
{
  const char delim = '"';
  
  raptor_iostream_write_byte(delim, iostr);
  if(raptor_string_ntriples_write(string, len, delim, iostr))
    return 1;
  
  raptor_iostream_write_byte(delim, iostr);

  return 0;
}


static void
rasqal_sparql_query_language_register_factory(rasqal_query_language_factory *factory)
{
  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;
}


int
rasqal_init_query_language_sparql(rasqal_world* world) {
  return rasqal_query_language_register_factory(world,
                                                "sparql", 
                                                "SPARQL W3C DAWG RDF Query Language",
                                                NULL,
                                                (const unsigned char*)"http://www.w3.org/TR/rdf-sparql-query/",
                                                &rasqal_sparql_query_language_register_factory);
}

int
rasqal_init_query_language_laqrs(rasqal_world* world) {
  return rasqal_query_language_register_factory(world,
                                                "laqrs", 
                                                "LAQRS adds to Querying RDF in SPARQL",
                                                NULL,
                                                NULL,
                                                &rasqal_sparql_query_language_register_factory);
}


#ifdef STANDALONE
#include <stdio.h>
#include <locale.h>
#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifndef HAVE_GETOPT
#include <rasqal_getopt.h>
#endif

#ifdef NEED_OPTIND_DECLARATION
extern int optind;
extern char *optarg;
#endif

#define GETOPT_STRING "di:"

#define SPARQL_FILE_BUF_SIZE 2048

int
main(int argc, char *argv[]) 
{
  const char *program = rasqal_basename(argv[0]);
  char query_string[SPARQL_FILE_BUF_SIZE];
  rasqal_query *query;
  FILE *fh;
  int rc;
  const char *filename = NULL;
  raptor_uri* base_uri = NULL;
  unsigned char *uri_string;
  const char* query_languages[2] = {"sparql", "laqrs"};
  const char* query_language;
  int usage = 0;
  rasqal_world *world;
  
  query_language=query_languages[0];
  
  filename = getenv("SPARQL_QUERY_FILE");
    
  while(!usage) {
    int c = getopt (argc, argv, GETOPT_STRING);

    if (c == -1)
      break;

    switch (c) {
      case 0:
      case '?': /* getopt() - unknown option */
        usage = 1;
        break;
        
      case 'd':
#if RASQAL_DEBUG > 2
        sparql_parser_debug = 1;
#endif
        break;
  
      case 'i':
        if(optarg) {
          if(!strcmp(optarg, "laqrs")) {
            query_language = query_languages[1];
          } else if(!strcmp(optarg, "sparql")) {
            query_language = query_languages[0];
          } else {
            fprintf(stderr, "-i laqrs or -i sparql only\n");
            usage = 1;
          }
        }
        break;
    }
  }

  if(!filename) {
    if((argc-optind) != 1) {
      fprintf(stderr, "%s: Too many arguments.\n", program);
      usage = 1;
    } else
      filename = argv[optind];
  }
  
  if(usage) {
    fprintf(stderr, "SPARQL/LAQRS parser test for Rasqal %s\n", 
            rasqal_version_string);
    fprintf(stderr, "USAGE: %s [OPTIONS] SPARQL-QUERY-FILE\n", program);
    fprintf(stderr, "OPTIONS:\n");
#if RASQAL_DEBUG > 2
    fprintf(stderr, " -d           Bison parser debugging\n");
#endif
    fprintf(stderr, " -i LANGUAGE  Set query language\n");
    exit(1);
  }


 fh = fopen(filename, "r");
 if(!fh) {
   fprintf(stderr, "%s: Cannot open file %s - %s\n", program, filename,
           strerror(errno));
   exit(1);
 }
 
  memset(query_string, 0, SPARQL_FILE_BUF_SIZE);
  rc=fread(query_string, SPARQL_FILE_BUF_SIZE, 1, fh);
  if(rc < SPARQL_FILE_BUF_SIZE) {
    if(ferror(fh)) {
      fprintf(stderr, "%s: file '%s' read failed - %s\n",
              program, filename, strerror(errno));
      fclose(fh);
      return(1);
    }
  }
  
  fclose(fh);

  world = rasqal_new_world();
  if(!world || rasqal_world_open(world))
    exit(1);

  query = rasqal_new_query(world, query_language, NULL);

  uri_string = raptor_uri_filename_to_uri_string(filename);
  base_uri = raptor_new_uri(world->raptor_world_ptr, uri_string);

  rc = rasqal_query_prepare(query, 
                            (const unsigned char*)query_string, base_uri);

  rasqal_query_print(query, stdout);

  rasqal_free_query(query);

  raptor_free_uri(base_uri);

  raptor_free_memory(uri_string);

  rasqal_free_world(world);

  return rc;
}
#endif

